Package: velociraptor
Title: Toolkit for Single-Cell Velocity
Version: 1.23.0
Date: 2026-04-15
Authors@R: c(person("Kevin", "Rue-Albrecht", role = c("aut", "cre"), email = "kevinrue67@gmail.com", comment = c(ORCID = "0000-0003-3899-3872")),
    person("Aaron", "Lun", role="aut", email="infinite.monkeys.with.keyboards@gmail.com", comment = c(ORCID = '0000-0002-3564-4813')),
    person("Charlotte", "Soneson", role="aut", email="charlottesoneson@gmail.com", comment = c(ORCID = '0000-0003-3833-2169')),
    person("Michael", "Stadler", role="aut", email="michael.stadler@fmi.ch", comment = c(ORCID = '0000-0002-2269-4934')))
Description: This package provides Bioconductor-friendly wrappers for RNA velocity calculations in single-cell RNA-seq data.
    We use the basilisk package to manage Conda environments,
    and the zellkonverter package to convert data structures between SingleCellExperiment (R) and AnnData (Python).
    The information produced by the velocity methods is stored in the various components of the SingleCellExperiment class.
Depends: SummarizedExperiment
Imports: methods, stats, Matrix, BiocGenerics, reticulate, S4Vectors,
        DelayedArray, basilisk, zellkonverter, scuttle,
        SingleCellExperiment, BiocParallel, BiocSingular
Suggests: BiocStyle, testthat, knitr, rmarkdown, pkgdown, scran,
        scater, scRNAseq, Rtsne, graphics, grDevices, ggplot2, cowplot,
        GGally, patchwork, metR
StagedInstall: no
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
URL: https://github.com/kevinrue/velociraptor
BugReports: https://github.com/kevinrue/velociraptor/issues
biocViews: SingleCell, GeneExpression, Sequencing, Coverage
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/velociraptor
git_branch: devel
git_last_commit: 280d050
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-30 01:04:42 UTC; biocbuild
Author: Kevin Rue-Albrecht [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-3899-3872>),
  Aaron Lun [aut] (ORCID: <https://orcid.org/0000-0002-3564-4813>),
  Charlotte Soneson [aut] (ORCID:
    <https://orcid.org/0000-0003-3833-2169>),
  Michael Stadler [aut] (ORCID: <https://orcid.org/0000-0002-2269-4934>)
Maintainer: Kevin Rue-Albrecht <kevinrue67@gmail.com>

# velociraptor

<!-- badges: start -->
[![R build status](https://github.com/kevinrue/velociraptor/workflows/build_check_deploy/badge.svg)](https://github.com/kevinrue/velociraptor/actions)
[![Codecov.io coverage status](https://codecov.io/github/kevinrue/velociraptor/coverage.svg?branch=master)](https://codecov.io/github/kevinrue/velociraptor)
[![Docker Cloud Automated build](https://img.shields.io/docker/cloud/automated/kevinrue/velociraptor)](https://hub.docker.com/r/kevinrue/velociraptor)
<!-- badges: end -->

_velociraptor_ provides an R toolkit for single-cell velocity computation.

## Bioconductor release status

|      Branch      |    R CMD check   | Last updated |
|:----------------:|:----------------:|:------------:|
| [_devel_](http://bioconductor.org/packages/devel/bioc/html/velociraptor.html) | [![Bioconductor-devel Build Status](http://bioconductor.org/shields/build/devel/bioc/velociraptor.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/velociraptor) | ![Latest commit](http://bioconductor.org/shields/lastcommit/devel/bioc/velociraptor.svg) |
| [_release_](http://bioconductor.org/packages/release/bioc/html/velociraptor.html) | [![Bioconductor-release Build Status](http://bioconductor.org/shields/build/release/bioc/velociraptor.svg)](http://bioconductor.org/checkResults/release/bioc-LATEST/velociraptor) | ![[Latest commit](http://bioconductor.org/shields/lastcommit/release/bioc/velociraptor.svg) |

## Installation

_velociraptor_ can be easily installed from [Bioconductor](https://bioconductor.org/packages/velociraptor/) using `BiocManager::install()`:

```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("velociraptor")
# or also...
BiocManager::install("velociraptor", dependencies = TRUE)
```

Setting `dependencies = TRUE` should ensure that all packages, including the ones in the `Suggests:` field of the `DESCRIPTION` file, are installed - this can be essential if you want to reproduce the code in the vignette, for example.

# Designing new environments

## Approach

In `basilisk.R`, start with the latest version of `scvelo`, e.g.

```{r}
.scvelo.dependencies.Windows <- list(
  channels = c("bioconda", "conda-forge"),
  packages = c(
    'scvelo==0.3.2'
  )
)
```

Install `velociraptor` and try running the examples in `?scvelo`.

Debug from there :)

## Windows ----

.scvelo.dependencies.Windows <- list(
  packages = c(
    'anndata==0.11.4',
    'array-api-compat==1.12.0',
    'click==8.2.1',
    'colorama==0.4.6',
    'contourpy==1.3.2',
    'cycler==0.12.1',
    'fonttools==4.58.5',
    'h5py==3.14.0',
    'joblib==1.5.1',
    'kiwisolver==1.4.8',
    'legacy-api-wrap==1.4.1',
    'llvmlite==0.44.0',
    'loompy==3.0.8',
    'matplotlib==3.10.3',
    'natsort==8.4.0',
    'networkx==3.5',
    'numba==0.61.2',
    'numpy==2.2.6',
    'numpy-groupies==0.11.3',
    'packaging==25.0',
    'pandas==2.3.1',
    'patsy==1.0.1',
    'pillow==11.3.0',
    'pip==25.1.1',
    'pynndescent==0.5.13',
    'pyparsing==3.2.3',
    'python-dateutil==2.9.0.post0',
    'pytz==2025.2',
    'scanpy==1.11.3',
    'scikit-learn==1.7.0',
    'scipy==1.15.3',
    'scvelo==0.3.3',
    'seaborn==0.13.2',
    'session-info2==0.1.2',
    'setuptools==80.9.0',
    'six==1.17.0',
    'statsmodels==0.14.5',
    'threadpoolctl==3.6.0',
    'tqdm==4.67.1',
    'typing_extensions==4.14.1',
    'tzdata==2025.2',
    'umap-learn==0.5.9.post2',
    'wheel==0.45.1'
  )
)

## LinuxAarch64 ----

.scvelo.dependencies.LinuxAarch64 <- list(
  packages = c(
    'anndata==0.11.4',
    'array-api-compat==1.12.0',
    'click==8.2.1',
    'contourpy==1.3.2',
    'cycler==0.12.1',
    'fonttools==4.58.5',
    'h5py==3.14.0',
    'joblib==1.5.1',
    'kiwisolver==1.4.8',
    'legacy-api-wrap==1.4.1',
    'llvmlite==0.44.0',
    'loompy==3.0.8',
    'matplotlib==3.10.3',
    'natsort==8.4.0',
    'networkx==3.5',
    'numba==0.61.2',
    'numpy==2.2.6',
    'numpy-groupies==0.11.3',
    'packaging==25.0',
    'pandas==2.3.1',
    'patsy==1.0.1',
    'pillow==11.3.0',
    'pip==25.1.1',
    'pynndescent==0.5.13',
    'pyparsing==3.2.3',
    'python-dateutil==2.9.0.post0',
    'pytz==2025.2',
    'scanpy==1.11.3',
    'scikit-learn==1.7.0',
    'scipy==1.15.3',
    'scvelo==0.3.3',
    'seaborn==0.13.2',
    'session-info2==0.1.2',
    'setuptools==80.9.0',
    'six==1.17.0',
    'statsmodels==0.14.5',
    'threadpoolctl==3.6.0',
    'tqdm==4.67.1',
    'typing_extensions==4.14.1',
    'tzdata==2025.2',
    'umap-learn==0.5.9.post2',
    'wheel==0.45.1'
  )
)

## Linux ----

.scvelo.dependencies.Linux <- list(
  packages = c(
    'anndata==0.11.4',
    'array-api-compat==1.12.0',
    'click==8.2.1',
    'contourpy==1.3.2',
    'cycler==0.12.1',
    'fonttools==4.58.5',
    'h5py==3.14.0',
    'joblib==1.5.1',
    'kiwisolver==1.4.8',
    'legacy-api-wrap==1.4.1',
    'llvmlite==0.44.0',
    'loompy==3.0.8',
    'matplotlib==3.10.3',
    'natsort==8.4.0',
    'networkx==3.5',
    'numba==0.61.2',
    'numpy==2.2.6',
    'numpy-groupies==0.11.3',
    'packaging==25.0',
    'pandas==2.3.1',
    'patsy==1.0.1',
    'pillow==11.3.0',
    'pip==25.1.1',
    'pynndescent==0.5.13',
    'pyparsing==3.2.3',
    'python-dateutil==2.9.0.post0',
    'pytz==2025.2',
    'scanpy==1.11.3',
    'scikit-learn==1.7.0',
    'scipy==1.15.3',
    'scvelo==0.3.3',
    'seaborn==0.13.2',
    'session-info2==0.1.2',
    'setuptools==80.9.0',
    'six==1.17.0',
    'statsmodels==0.14.5',
    'threadpoolctl==3.6.0',
    'tqdm==4.67.1',
    'typing_extensions==4.14.1',
    'tzdata==2025.2',
    'umap-learn==0.5.9.post2',
    'wheel==0.45.1'
  )
)

## MacOSXArm ----

.scvelo.dependencies.MacOSXArm <- list(
  packages = c(
    'anndata==0.11.4',
    'array-api-compat==1.14.0',
    'asciitree==0.3.3',
    'asttokens==3.0.1',
    'certifi==2026.2.25',
    'click==8.3.2',
    'comm==0.2.3',
    'contourpy==1.3.3',
    'cycler==0.12.1',
    'decorator==5.2.1',
    'Deprecated==1.3.1',
    'donfig==0.8.1.post1',
    'executing==2.2.1',
    'fast-array-utils==1.4.1',
    'fasteners==0.20',
    'fonttools==4.62.1',
    'google-crc32c==1.8.0',
    'h5py==3.16.0',
    'ipython==9.12.0',
    'ipython_pygments_lexers==1.1.1',
    'ipywidgets==8.1.8',
    'jedi==0.19.2',
    'joblib==1.5.3',
    'jupyterlab_widgets==3.0.16',
    'kiwisolver==1.5.0',
    'legacy-api-wrap==1.5',
    'llvmlite==0.47.0',
    'loompy==3.0.8',
    'matplotlib==3.10.8',
    'matplotlib-inline==0.2.1',
    'natsort==8.4.0',
    'networkx==3.6.1',
    'numba==0.65.0',
    'numcodecs==0.15.1',
    'numpy==2.4.4',
    'numpy-groupies==0.11.3',
    'packaging==26.1',
    'pandas==2.3.3',
    'parso==0.8.6',
    'patsy==1.0.2',
    'pexpect==4.9.0',
    'pillow==12.2.0',
    'pip==26.0.1',
    'prompt_toolkit==3.0.52',
    'ptyprocess==0.7.0',
    'pure_eval==0.2.3',
    'Pygments==2.20.0',
    'pynndescent==0.6.0',
    'pyparsing==3.3.2',
    'python-dateutil==2.9.0.post0',
    'pytz==2026.1.post1',
    'PyYAML==6.0.3',
    'scanpy==1.12.1',
    'scikit-learn==1.8.0',
    'scipy==1.15.2',
    'scvelo==0.3.3',
    'seaborn==0.13.2',
    'session-info2==0.4.1',
    'setuptools==82.0.1',
    'six==1.17.0',
    'stack-data==0.6.3',
    'statsmodels==0.14.6',
    'threadpoolctl==3.6.0',
    'tqdm==4.67.3',
    'traitlets==5.14.3',
    'typing_extensions==4.15.0',
    'tzdata==2026.1',
    'umap-learn==0.5.12',
    'wcwidth==0.6.0',
    'widgetsnbextension==4.0.15',
    'wrapt==2.1.2',
    'zarr==2.18.7'
  )
)

## MacOSX ----

.scvelo.dependencies.MacOSX <- list(
  packages = c(
    'anndata==0.11.4',
    'array-api-compat==1.12.0',
    'click==8.2.1',
    'contourpy==1.3.2',
    'cycler==0.12.1',
    'fonttools==4.58.5',
    'h5py==3.14.0',
    'joblib==1.5.1',
    'kiwisolver==1.4.8',
    'legacy-api-wrap==1.4.1',
    'llvmlite==0.44.0',
    'loompy==3.0.8',
    'matplotlib==3.10.3',
    'natsort==8.4.0',
    'networkx==3.5',
    'numba==0.61.2',
    'numpy==2.2.6',
    'numpy-groupies==0.11.3',
    'packaging==25.0',
    'pandas==2.3.1',
    'patsy==1.0.1',
    'pillow==11.3.0',
    'pip==25.1.1',
    'pynndescent==0.5.13',
    'pyparsing==3.2.3',
    'python-dateutil==2.9.0.post0',
    'pytz==2025.2',
    'scanpy==1.11.3',
    'scikit-learn==1.7.0',
    'scipy==1.15.3',
    'scvelo==0.3.3',
    'seaborn==0.13.2',
    'session-info2==0.1.2',
    'setuptools==80.9.0',
    'six==1.17.0',
    'statsmodels==0.14.5',
    'threadpoolctl==3.6.0',
    'tqdm==4.67.1',
    'typing_extensions==4.14.1',
    'tzdata==2025.2',
    'umap-learn==0.5.9.post2',
    'wheel==0.45.1'
  )
)

# Switch environment ----

#' @importFrom basilisk isWindows
#' @importFrom basilisk isLinuxAarch64
#' @importFrom basilisk isLinux
#' @importFrom basilisk isMacOSXArm
#' @importFrom basilisk isMacOSX
if (basilisk::isWindows()) {
  .scvelo_dependencies <- .scvelo.dependencies.Windows
} else if (basilisk::isLinuxAarch64()) {
  .scvelo_dependencies <- .scvelo.dependencies.LinuxAarch64
} else if (basilisk::isLinux()) {
  .scvelo_dependencies <- .scvelo.dependencies.Linux
} else if (basilisk::isMacOSXArm()) {
  .scvelo_dependencies <- .scvelo.dependencies.MacOSXArm
} else if (basilisk::isMacOSX()) {
  .scvelo_dependencies <- .scvelo.dependencies.MacOSX
} else {
  stop("Unsupported operating system or architecture.\n  Please open an issue at <https://github.com/kevinrue/velociraptor/issues> to request support.")
}

#' @importFrom basilisk BasiliskEnvironment
#' @importFrom zellkonverter AnnDataDependencies
velo.env <- BasiliskEnvironment("env", "velociraptor", packages=.scvelo_dependencies$packages)

#' Phase and velocity graphs for a set of genes
#'
#' For a each gene in a set of genes, show the phase graph (spliced versus
#' unspliced counts and fitted model) and reduced dimension graphs with
#' cell colored by velocity and (spliced) expression.
#'
#' @param x A \linkS4class{SingleCellExperiment} object with RNA velocity results
#'   as returned by \code{\link{scvelo}}, and low-dimensional coordinates, e.g.,
#'   after t-SNE, in its \code{\link{reducedDims}}.
#' @param genes A character vector with one or several genes for which to plot
#'   phase and velocity graphs. \code{genes} have to be in \code{rownames(x)}.
#' @param use.dimred String or integer scalar specifying the reduced dimensions
#'   to retrieve from \code{x}.
#' @param assay.splicedM An integer scalar or string specifying the assay of
#'   \code{x} containing the moments of spliced abundances.
#' @param assay.unsplicedM An integer scalar or string specifying the assay of
#'   \code{x} containing the moments unspliced abundances.
#' @param which.plots A character vector specifying which plots to create for
#'   each gene. Possible values are \code{"phase", "velocity", "expression"} and
#'   correspond to the phase graph or reduced dimension graphs with cells
#'   colored by velocity or (spliced) expression.
#' @param genes.per.row An integer scalar with the numbers of genes to visualize
#'   per row of plots. For example, if \code{which.plots =  c("phase","expression")}
#'   and \code{genes.per.row = 2}, the resulting figure will have four plot
#'   panels per row.
#' @param color_by A character scalar specifying a column in \code{colData(x)}
#'   to color cells in the phase graph. Alternatively, \code{color_by} can be
#'   set to vector of valid R colors, either of length one (recycled for all
#'   cells) or of length \code{ncol(x)}, which will then be used to color cells
#'   in the phase graph.
#' @param color.alpha An integer scalar giving the transparency of colored
#'   cells. Possible values are between 0 (fully transparent) and 1.0 (opaque).
#' @param colors.velocity,colors.expression Character vectors specifying the
#'   color ranges used for mapping velocities and expression values. The
#'   defaults are \code{RColorBrewer::brewer.pal(11, "RdYlGn")} for the
#'   velocities and \code{viridisLite::viridis(11)} for the expression values.
#' @param max.abs.velo A numeric scalar greater than zero giving the maximum
#'   absolute velocity to limit the color scale for the \code{"velocity"} graph.
#'
#' @details Please note that \code{plotVelocity} will modify parameters of
#'   the current graphics device using \code{\link{layout}} and \code{\link{par}},
#'   in order to create the layout for the generated graph panels.
#' 
#' @return A patchwork object with the plots selected by \code{which.plot} for
#'   the genes in \code{genes}, arranged in a grid according to \code{genes.per.row}.
#'
#' @author Michael Stadler
#' 
#' @examples
#' library(scuttle)
#' set.seed(42)
#' sce1 <- mockSCE(ncells = 100, ngenes = 500)
#' sce2 <- mockSCE(ncells = 100, ngenes = 500)
#'
#' datlist <- list(X=counts(sce1), spliced=counts(sce1), unspliced=counts(sce2))
#'
#' out1 <- scvelo(datlist, mode = "steady_state")
#' out2 <- scvelo(datlist, mode = "dynamical")
#' 
#' plotVelocity(out1, c("Gene_0031","Gene_0268"))
#' plotVelocity(out2, c("Gene_0031","Gene_0268"))
#'
#' @seealso 
#' \code{\link{scvelo}}, to generate \code{x},
#' \code{\link[RColorBrewer]{brewer.pal}} and \code{\link[viridisLite]{viridis}}
#' for creation of color palettes, packages \pkg{ggplot2} and \pkg{patchwork}
#' used to generate and arrange the plots.
#' 
#' @export
#' @importFrom SummarizedExperiment assay rowData
#' @importFrom SingleCellExperiment reducedDim reducedDims reducedDimNames
plotVelocity <- function(x, genes, use.dimred = 1,
                         assay.splicedM = "Ms", assay.unsplicedM = "Mu",
                         which.plots = c("phase", "velocity", "expression"),
                         genes.per.row = 1,
                         color_by = "#222222",
                         color.alpha = 0.4,
                         colors.velocity = c("#A50026", "#D73027", "#F46D43",
                                              "#FDAE61", "#FEE08B", "#FFFFBF",
                                              "#D9EF8B", "#A6D96A", "#66BD63",
                                              "#1A9850", "#006837"),
                         colors.expression = c("#440154", "#482576", "#414487",
                                                "#35608D", "#2A788E", "#21908C",
                                                "#22A884", "#43BF71", "#7AD151",
                                                "#BBDF27", "#FDE725"),
                         max.abs.velo = 0.001) {
    # check arguments
    genes <- unique(genes)
    if (!all(genes %in% rownames(x))) {
        stop("not all 'genes' are not found in 'x'")
    }
    stopifnot(exprs = {
        all(which.plots %in% c("phase", "velocity", "expression"))
        is.numeric(genes.per.row)
        length(genes.per.row) == 1L
        is.numeric(max.abs.velo)
        length(max.abs.velo) == 1L
        max.abs.velo >= 0.0
    })
    if (is.numeric(use.dimred)) {
        stopifnot(exprs = {
            length(use.dimred) == 1L
            use.dimred <= length(reducedDims(x))
        })
        use.dimred <- reducedDimNames(x)[use.dimred]
    } else if (is.character(use.dimred)) {
        stopifnot(exprs = {
            length(use.dimred) == 1L
            use.dimred %in% reducedDimNames(x)
        })
    } else {
        stop("'use.dimred' is not a valid value for use in reducedDim(x, use.dimred)")
    }

    # extract data from x
    S <- assay(x, assay.splicedM)
    U <- assay(x, assay.unsplicedM)
    V <- assay(x, "velocity")
    rd <- rowData(x)
    xy <- reducedDim(x, use.dimred)
    df2 <- data.frame(x = xy[, 1],
                      y = xy[, 2])

    
    # iterate over genes and create graphs
    pL <- list()
    for (gene in genes) {
        df1 <- data.frame(s = as.vector(S[gene, ]),
                          u = as.vector(U[gene, ]))

        # spliced/unspliced phase portrait with model estimates
        if ("phase" %in% which.plots) {
            if (is.character(color_by) && length(color_by) == 1L && color_by %in% colnames(colData(x))) {
                df1$col <- factor(colData(x)[, color_by])
                colByFeat <- TRUE
            } else if (length(color_by) == 1L || length(color_by) == ncol(x)) {
                df1$col <- color_by
                colByFeat <- FALSE
            } else {
                stop("invalid 'colour_by' (not in colData(x), nor of the right length)")
            }
            p1 <- ggplot2::ggplot(df1, ggplot2::aes(x = !!ggplot2::sym("s"),
                                                    y = !!ggplot2::sym("u"))) +
                ggplot2::xlim(0, max(df1$s, na.rm = TRUE)) +
                ggplot2::ylim(0, max(df1$u, na.rm = TRUE)) +
                ggplot2::labs(title = gene, x = "spliced", y = "unspliced") +
                ggplot2::theme_minimal() +
                ggplot2::theme(panel.grid.major = ggplot2::element_blank(),
                               panel.grid.minor = ggplot2::element_blank(),
                               axis.ticks = ggplot2::element_line(color = "grey20"),
                               panel.border = ggplot2::element_rect(fill = NA, color = "grey20"))
            if (colByFeat) {
                p1 <- p1 + ggplot2::geom_point(ggplot2::aes(color = !!ggplot2::sym("col")),
                                               alpha = color.alpha, show.legend = FALSE)
            } else {
                p1 <- p1 + ggplot2::geom_point(color = df1$col, alpha = color.alpha)
            }

            # gene specific model parameters
            #   scvelo(..., mode = "dynamical") creates "fit_" prefixes,
            #   all other modes only have "velocity_gamma"
            if ("fit_gamma" %in% colnames(rd)) {
                alpha <- rd[gene, "fit_alpha"]
                beta <- rd[gene, "fit_beta"] * rd[gene, "fit_scaling"]
                gamma <- rd[gene, "fit_gamma"]
                scaling <- rd[gene, "fit_scaling"]
                # t_ is the pseudotime separating the increase/decrease phases
                t_ <- rd[gene, "fit_t_"]
            } else {
                alpha <- beta <- scaling <- t_ <- NULL
                if ("velocity_gamma" %in% colnames(rd)) {
                    gamma <- rd[gene, "velocity_gamma"]
                } else {
                    gamma <- NULL
                }
            }
            
            # steady-state ratio
            if (!is.null(gamma) && is.finite(gamma)) {
                if (!is.null(beta) && is.finite(beta)) {
                    # in the dynamical model
                    p1 <- p1 + ggplot2::geom_abline(intercept = 0,
                                                    slope = gamma / beta * scaling,
                                                    linetype = "dashed")
                } else {
                    # in a static model
                    p1 <- p1 + ggplot2::geom_abline(intercept = 0,
                                                    slope = gamma,
                                                    linetype = "dashed")
                }
            }

            # dynamic model curve
            if (!is.null(beta) && is.finite(beta)) {
                # calculate spliced and unspliced abundances from initial
                #   conditions and fitted model parameters
                # see https://github.com/theislab/scvelo/blob/95d90de3d0935ce58a01218c9f179c9494ff593e/scvelo/plotting/simulation.py#L26
                if (all(c("fit_u0","fit_s0") %in% colnames(rd))) {
                    u0_offset <- rd[gene, "fit_u0"]
                    s0_offset <- rd[gene, "fit_s0"]
                } else {
                    u0_offset <- s0_offset <- 0
                }
                # see https://github.com/theislab/scvelo/blob/95d90de3d0935ce58a01218c9f179c9494ff593e/scvelo/tools/dynamical_model_utils.py#L602
                ft <- as.vector(assay(x, "fit_t")[gene, ])
                o <- as.numeric(ft < t_) # 1 or 0 for cells increasing or decreasing this gene's expression
                tau <- ft * o + (ft - t_) * (1 - o)
                u0 <- s0 <- alpha0 <- 0
                u0_ <- .unspliced(t_, u0, alpha, beta)
                s0_ <- .spliced(t_, s0, u0, alpha, beta, gamma)
                u0 <- u0 * o + u0_ * (1 - o)
                s0 <- s0 * o + s0_ * (1 - o)
                alpha <- alpha * o + alpha0 * (1 - o)
                # see https://github.com/theislab/scvelo/blob/95d90de3d0935ce58a01218c9f179c9494ff593e/scvelo/plotting/simulation.py#L54
                ut <- .unspliced(tau, u0, alpha, beta) * scaling + u0_offset
                st <- .spliced(tau, s0, u0, alpha, beta, gamma) + s0_offset
                p1 <- p1 + ggplot2::geom_point(data = data.frame(x = st, y = ut),
                                               mapping = ggplot2::aes(x = !!ggplot2::sym("x"),
                                                                      y = !!ggplot2::sym("y")),
                                               color = "purple", shape = 46)
            }
            pL <- c(pL, list(p1))
        }
        
        # velocity plot
        if ("velocity" %in% which.plots) {
            df2$z <- as.vector(V[gene, ])
            if (all(!is.finite(df2$z))) {
                warning("velocity estimates for ", gene, " are all non-finite")
            }
            mx <- max(c(max.abs.velo, abs(df2$z)), na.rm = TRUE)
            p2 <- ggplot2::ggplot(df2, ggplot2::aes(x = !!ggplot2::sym("x"),
                                                    y = !!ggplot2::sym("y"),
                                                    color = !!ggplot2::sym("z"))) +
                ggplot2::geom_point(alpha = color.alpha) +
                ggplot2::scale_color_gradientn(colours = colors.velocity,
                                               limits = c(-mx, mx)) +
                ggplot2::labs(title = "velocity", x = paste0(use.dimred, " 1"),
                              y = paste0(use.dimred, " 2"), color = ggplot2::element_blank()) +
                ggplot2::theme_minimal() +
                ggplot2::theme(axis.text = ggplot2::element_blank(),
                               panel.grid.major = ggplot2::element_blank(),
                               panel.grid.minor = ggplot2::element_blank())
            pL <- c(pL, list(p2))
        }
        
        # expression plot
        if ("expression" %in% which.plots) {
            df2$z <- as.vector(S[gene, ])
            p3 <- ggplot2::ggplot(df2, ggplot2::aes(x = !!ggplot2::sym("x"),
                                                    y = !!ggplot2::sym("y"),
                                                    color = !!ggplot2::sym("z"))) +
                ggplot2::geom_point(alpha = color.alpha) +
                ggplot2::scale_color_gradientn(colours = colors.expression) +
                ggplot2::labs(title = "expression", x = paste0(use.dimred, " 1"),
                              y = paste0(use.dimred, " 2"), color = ggplot2::element_blank()) +
                ggplot2::theme_minimal() +
                ggplot2::theme(axis.text = ggplot2::element_blank(),
                               panel.grid.major = ggplot2::element_blank(),
                               panel.grid.minor = ggplot2::element_blank())
            pL <- c(pL, list(p3))
        }
    }
    
    # create plot panel layout
    nplts <- length(unique(which.plots))
    nrows <- ceiling(length(genes) / genes.per.row)
    p <- do.call(patchwork::wrap_plots, c(pL, list(nrow = nrows)))

    return(p)
}

# helper functions to calculate (un)spliced counts from starting point and model parameters
# see https://github.com/theislab/scvelo/blob/95d90de3d0935ce58a01218c9f179c9494ff593e/scvelo/tools/dynamical_model_utils.py#L109
.unspliced <- function(tau, u0, alpha, beta) {
    expu <- exp(-beta * tau)
    return(u0 * expu + alpha / beta * (1 - expu))
}
# see https://github.com/theislab/scvelo/blob/95d90de3d0935ce58a01218c9f179c9494ff593e/scvelo/tools/dynamical_model_utils.py#L114
.spliced <- function(tau, s0, u0, alpha, beta, gamma) {
    cn <- (alpha - u0 * beta) * 1 / (gamma - beta)
    expu <- exp(-beta * tau)
    exps <- exp(-gamma * tau)
    return(s0 * exps + alpha / gamma * (1 - exps) + cn * (exps - expu))
}

# This tests the plotting functionality.
# library(testthat); library(velociraptor); source("test-plotting.R")

library(scuttle)
#' set.seed(42)
sce1 <- mockSCE()
sce2 <- mockSCE()

spliced <- counts(sce1)
unspliced <- counts(sce2)
datlist <- list(X=counts(sce1), spliced=counts(sce1), unspliced=counts(sce2))

set.seed(100001)
out1 <- scvelo(datlist, mode = "steady_state")
out2 <- scvelo(datlist, mode = "dynamical")

genes1 <- rownames(out2)[!is.finite(rowData(out2)$fit_alpha)][1:2]
genes2 <- rownames(out2)[is.finite(rowData(out2)$fit_alpha)][1:2]

tsne.results <- matrix(rnorm(2*ncol(out1)), ncol=2)

em1 <- embedVelocity(reducedDim(out1, 1), out1)[,1:2]
em2 <- embedVelocity(reducedDim(out2, 1), out2)[,1:2]

out3 <- out1
colData(out3) <- cbind(colData(out3), type = sample(letters, ncol(out3), replace = TRUE))
rowData(out3) <- rowData(out3)[, -grep("gamma", colnames(rowData(out3)))]

out4 <- out2
rowData(out4) <- rowData(out4)[, -grep("fit_[us]0", colnames(rowData(out4)))]

test_that("plotVelocity runs", {
    
    skip_if_not_installed("ggplot2")
    skip_if_not_installed("patchwork")
    
    expect_error(plotVelocity("error", genes2))
    expect_error(plotVelocity(out1, "error"))
    expect_error(plotVelocity(out1, genes2, use.dimred = "error"))
    expect_error(plotVelocity(out1, genes2, use.dimred = FALSE))
    expect_error(plotVelocity(out1, genes2, 1, "error"))
    expect_error(plotVelocity(out1, genes2, 1, which.plots = "error"))
    expect_error(plotVelocity(out1, genes2, 1, genes.per.row = "error"))
    expect_error(plotVelocity(out1, genes2, 1, color_by = c("error", "error")))
    expect_error(plotVelocity(out1, genes2, 1, max.abs.velo = "error"))
    expect_error(plotVelocity(out1, genes2, 1, max.abs.velo = -1))
    

    tf <- tempfile(fileext = ".png")
    png(tf)
    expect_is(res0 <- plotVelocity(out1, genes1, which.plots = "phase", color_by = "#44444422"), "patchwork")
    print(res0)
    expect_is(res1 <- plotVelocity(out1, genes1), "patchwork")
    print(res1)
    expect_warning(res2 <- plotVelocity(out2, genes1))
    expect_is(res2, "patchwork")
    print(res2)
    expect_is(res3 <- plotVelocity(out4, genes2), "patchwork")
    print(res3)
    expect_is(res4 <- plotVelocity(out3, genes2, which.plots = "phase", color_by = "type"), "patchwork")
    print(res4)
    expect_is(res5 <- plotVelocity(out2, genes2), "patchwork")
    print(res5)
    dev.off()
    expect_true(file.exists(tf))
    unlink(tf)
})

test_that("plotVelocityStream runs", {
  # metR::geom_streamline() layer causes timeouts on macOS 
  if (!basilisk::isMacOSX()) {
    skip_if_not_installed("ggplot2")
    skip_if_not_installed("metR")
    
    expect_error(plotVelocityStream("error", em2))
    expect_error(plotVelocityStream(out2, "error"))
    expect_error(plotVelocityStream(out2, em2[1:10, ]))
    expect_error(plotVelocityStream(out2, em2, use.dimred = "error"))
    expect_error(plotVelocityStream(out2, em2, use.dimred = FALSE))
    expect_error(plotVelocityStream(out2, em2, color_by = "error"))
    expect_error(plotVelocityStream(out2, em2, grid.resolution = "error"))
    expect_error(plotVelocityStream(out2, em2, scale = "error"))
    expect_error(plotVelocityStream(out2, em2, color.streamlines = "error"))
    
    tf <- tempfile(fileext = ".png")
    png(tf)
    expect_warning(print(plotVelocityStream(out2, em2, color_by = "#44444422")))
    print(plotVelocityStream(out2, em2))
    print(plotVelocityStream(out3, em2, color_by = "type"))
    print(plotVelocityStream(out2, em2, color.streamlines = TRUE))
    dev.off()
    expect_true(file.exists(tf))
    unlink(tf)
  }
})

#' Project velocities onto an embedding
#'
#' Project the velocity vector for each cell onto an existing low-dimensional embedding.
#'
#' @param x A numeric matrix of low-dimensional coordinates, e.g., after t-SNE.
#' Alternatively, a \linkS4class{SingleCellExperiment} containing such coordinates in its \code{\link{reducedDims}}.
#' @param vobj A \linkS4class{SingleCellExperiment} containing the output of the velocity calculations,
#' typically after running \code{\link{scvelo}}.
#' @param ... For the generic, further arguments to pass to specific methods.
#'
#' For the ANY method, further arguments to pass to the \code{velocity_embedding} Python function from \pkg{scVelo}.
#'
#' For the SingleCellExperiment method, further arguments to pass to the ANY method.
#' @param use.dimred String or integer scalar specifying the reduced dimensions to retrieve from \code{x}.
#'
#' @details
#' This is a simple wrapper around the \code{scvelo.tools.velocity_embedding} function.
#' Briefly, we construct a cell-cell transition matrix where a cell is more likely to transition to one of its neighbors
#' if its velocity vector is pointing in the same direction as that neighbor.
#' The resulting matrix is then used to compute a weighted average of the positions in \code{x},
#' allowing us to compute a velocity in the low-dimensional embedding.
#' 
#' @return
#' A numeric matrix of the same dimensions as \code{x}, containing the projected velocity vectors in that embedding.
#'
#' @author Aaron Lun
#' @examples
#' example(scvelo, echo=FALSE) # recycling that example.
#'
#' # Making up a new embedding.
#' tsne.results <- matrix(rnorm(2*ncol(out)), ncol=2)
#'
#' # Projecting the future state of each cell:
#' projected <- embedVelocity(tsne.results, out)
#'
#' @export
#' @name embedVelocity
NULL

#' @importFrom SingleCellExperiment reducedDim<-
.embed_velocity <- function(x, vobj, ...) {
    reducedDim(vobj, "X_target") <- as.matrix(x)
    colnames(reducedDim(vobj, "X_target")) <- NULL
    basiliskRun(env=velo.env, fun=.run_embedder, vobj=vobj, ...)
}

#' @importFrom reticulate import
#' @importFrom zellkonverter SCE2AnnData
.run_embedder <- function(vobj, ...) {
    scv <- import("scvelo")

    args <- list(..., basis="target", autoscale=FALSE)
    adata <- SCE2AnnData(vobj)

    do.call(scv$tl$velocity_embedding, c(list(data=adata), args))

    adata$obsm["velocity_target"]
}

#' @export
#' @rdname embedVelocity
setGeneric("embedVelocity", function(x, vobj, ...) standardGeneric("embedVelocity"))

#' @export
#' @rdname embedVelocity
setMethod("embedVelocity", "ANY", .embed_velocity)

#' @export
#' @rdname embedVelocity
setMethod("embedVelocity", "SingleCellExperiment", function(x, vobj, ..., use.dimred=1) {
    .embed_velocity(reducedDim(x, use.dimred), vobj, ...)
})

#' @importFrom DelayedArray is_sparse
.make_np_friendly <- function(x) {
    if (is_sparse(x)) {
        as(x, "dgCMatrix")
    } else {
        as.matrix(x)
    }
}

#' @importFrom DelayedArray t
.extractor_python_dict <- function(thing, names, single=FALSE, transpose=FALSE) {
    if (single) {
        values <- lapply(names, function(x) {
            if (transpose) t(thing[x])
            else thing[x]
        })
    } else {
        values <- lapply(names, function(x) {
            if (transpose) t(thing[[x]])
            else thing[[x]]
        })
    }
    names(values) <- names
    values
}

#' Summarize vectors into a grid
#'
#' Summarize the velocity vectors into a grid, usually for easy plotting.
#'
#' @param x A numeric matrix of low-dimensional coordinates, e.g., after t-SNE.
#' Alternatively, a \linkS4class{SingleCellExperiment} containing such coordinates in its \code{\link{reducedDims}}.
#' @param embedded A low-dimensional projection of the velocity vectors into the embedding of \code{x}.
#' This should be of the same dimensions as \code{x} and is typically produced by \code{\link{embedVelocity}}.
#' @param resolution Integer scalar specifying the resolution of the grid,
#' in terms of the number of grid intervals along each axis.
#' @param scale Logical scalar indicating whether the averaged vectors should be scaled by the grid resolution.
#' @param as.data.frame Logical scalar indicating whether the output should be a data.frame.
#' If \code{FALSE}, a list of two matrices is returned.
#' @param return.intermediates Logical scalar indicating whether intermediate objects should also be returned.
#' This enforces \code{as.data.frame=FALSE} and throws a warning if it is \code{TRUE}.
#' @param ... For the generic, further arguments to pass to specific methods.
#'
#' For the SingleCellExperiment method, further arguments to pass to the ANY method.
#' @param use.dimred String or integer scalar specifying the reduced dimensions to retrieve from \code{x}.
#'
#' @details
#' This partitions the bounding box of \code{x} into a grid with \code{resolution} units in each dimension.
#' The locations and vectors of all cells in each block are averaged to obtain a representative of that block.
#' This is most obviously useful for visualization to avoid overplotting of velocity vectors.
#'
#' If \code{scale=TRUE}, per-block vectors are scaled so that the median vector length is comparable to the spacing between blocks.
#' This improves visualization when the scales of \code{x} and \code{embedded} are not immediately comparable.
#'
#' @return
#' If \code{as.data.frame=FALSE}, a list is returned containing \code{start} and \code{end},
#' two numeric matrices with one row per non-empty block in the grid and one column per column in \code{x}.
#' \code{start} contains the mean location of all cells inside that block,
#' and \code{end} contains the endpoint after adding the (scaled) average of the block's cell's velocity vectors.
#'
#' If \code{as.data.frame=TRUE}, a data.frame is returned with numeric columns of the same contents as the list above.
#' Column names are prefixed by \code{start.*} and \code{end.*}.
#' 
#' If \code{return.intermediates=TRUE}, a list is returned (irrespective of the value of \code{as.data.frame})
#' that in addition to \code{start} and \code{end} also contains intermediate objects \code{limits}
#' (the ranges in x and y), \code{delta} (the grid intervals in x and y), \code{categories} (a
#' DataFrame with integer row and column indices for each cell that specify the grid field that it is
#' contained in), \code{grp} (numerical index of grid fields for each cell) and \code{vec} (velocity
#' vectors for non-empty grid fields).
#'
#' @author Aaron Lun
#' @examples
#' tsne.results <- matrix(rnorm(10000), ncol=2)
#' tsne.vectors <- matrix(rnorm(10000), ncol=2)
#'
#' out <- gridVectors(tsne.results, tsne.vectors)
#'
#' # Demonstration for plotting.
#' plot(tsne.results[,1], tsne.results[,2], col='grey')
#' arrows(out$start.1, out$start.2, out$end.1, out$end.2, length=0.05)
#'
#' @seealso 
#' \code{\link{embedVelocity}}, to generate \code{embedded}.
#' @name gridVectors
NULL

#' @export
#' @importFrom S4Vectors selfmatch DataFrame
#' @importFrom stats median
.grid_vectors <- function(x, embedded, resolution=40, scale=TRUE, as.data.frame=TRUE, return.intermediates=FALSE) {
    limits <- apply(x, 2, range)
    intercept <- limits[1,]
    delta <- (limits[2,] - intercept)/resolution

    categories <- t((t(x) - intercept)/delta)
    storage.mode(categories) <- "integer"
    categories <- DataFrame(categories)
    grp <- selfmatch(categories)

    tab <- as.integer(table(grp))
    pos <- rowsum(x, grp)/tab
    vec <- rowsum(embedded, grp)/tab

    if (scale) {
        d <- sqrt(rowSums(vec^2))
        target <- sqrt(sum(delta^2))
        vec <- vec * target/median(d)/2 # divide by 2 to avoid running over into another block.
    }

    if (return.intermediates) {
        if (as.data.frame) {
            warning("ignoring 'as.data.frame=TRUE' for 'return.intermediates=TRUE'")
        }
        return(list(start=pos, end=pos + vec, limits=limits, delta=delta,
                    categories=categories, grp=grp, vec=vec))
    } else {
        FUN <- if (as.data.frame) data.frame else list
        return(FUN(start=pos, end=pos + vec))
    }
}

#' @export
#' @rdname gridVectors
setGeneric("gridVectors", function(x, embedded, ...) standardGeneric("gridVectors"))

#' @export
#' @rdname gridVectors
setMethod("gridVectors", "ANY", .grid_vectors) 

#' @export
#' @rdname gridVectors
setMethod("gridVectors", "SingleCellExperiment", function(x, embedded, ..., use.dimred=1) {
    dimred <- reducedDim(x, use.dimred)
    colnames(dimred) <- NULL
    .grid_vectors(dimred, embedded, ...)
})

library(dplyr)
library(tidyr)

pkg_info <- read.table("/Users/kevin/Downloads/test-scvelo/pip.list.txt", skip = 2)
pkg_specs <- pkg_info %>%
    as_tibble() %>%
    unite("spec", V1, V2, sep = "==") %>%
    pull(spec)

cat(paste0(
    "c(",
    "\n",
    paste0("  ", "'", pkg_specs, "'", collapse = ",\n"),
    "\n",
    ")",
    "\n"
))

# paste the result in R/basilisk.R

m1_info <- read.table("M1_20240522.txt")[, 1:2]
intel_info <- read.table("Intel_20240601.txt")[, 1:2]
merged_info <- merge(m1_info, intel_info, by = "V1", suffixes = c(".m1", ".intel"))
merged_info[merged_info$V2.m1 != merged_info$V2.intel, ]

#' Velocity stream plot in low-dimensional space
#'
#' Plot velocities embedded into low-dimensional space as a stream plot. Stream
#' lines are lines that follow the gradient in the velocity field and illustrate
#' paths that cells could follow based on observed RNA velocities.
#'
#' @param sce A \linkS4class{SingleCellExperiment} object containing
#'   low-dimensional coordinates, e.g., after t-SNE, in its
#'   \code{\link{reducedDims}}.
#' @param embedded A low-dimensional projection of the velocity vectors into the
#'   embedding of \code{sce}. This should be of the same dimensions as \code{sce}
#'   and is typically produced by \code{\link{embedVelocity}}.
#' @param use.dimred String or integer scalar specifying the reduced dimensions
#'   to retrieve from \code{sce}.
#' @param color_by A character scalar specifying a column in \code{colData(sce)}
#'   to color cells in the phase graph. Alternatively, \code{color_by} can be
#'   set to a valid R color to be used to color cells.
#' @param color.alpha An integer scalar giving the transparency of colored
#'   cells. Possible values are between 0 (fully transparent) and 1.0 (opaque).
#' @param grid.resolution Integer scalar specifying the resolution of the grid,
#'   in terms of the number of grid intervals along each axis.
#' @param scale Logical scalar indicating whether the averaged vectors should be
#'   scaled by the grid resolution.
#' @param stream.L Integer scalar giving the typical length of a streamline
#'   low-dimensional space units.
#' @param stream.min.L A numeric scalar with the minimum length of segments to be shown.
#' @param stream.res Numeric scalar specifying the resolution of estimated
#'   streamlines (higher numbers increase smoothness of lines but also the time
#'   for computation).
#' @param stream.width A numeric scalar controlling the width of streamlines.
#' @param color.streamlines Logical scalar. If \code{TRUE} streamlines will
#'   be colored by local velocity. Arrows cannot be shown in that case.
#' @param color.streamlines.map A character vector specifying the
#'   color range used for mapping local velocities to streamline colors. The
#'   default is \code{viridisLite::viridis(11)}.
#' @param arrow.angle,arrow.length Numeric scalars giving the \code{angle} and
#'   \code{length} of arrowheads.
#'   
#' @details \code{grid.resolution} and \code{scale} are passed to
#'   \code{\link{gridVectors}}, which is used to summarized the velocity vectors
#'   into an initial grid. A full regular grid is computed from that and used
#'   in \code{\link[metR]{geom_streamline}} to calculate streamlines. The
#'   following arguments are passed to the arguments given in parenthesis of
#'   \code{\link[metR]{geom_streamline}}:
#'   \code{stream.L} (\code{L}), \code{stream.res} (\code{res}),
#'   \code{stream.min.L} (\code{min.L}), \code{arrow.angle} (\code{arrow.angle})
#'   and \code{arrow.length} (\code{arrow.length}).
#'   Streamlines are computed by simple integration with a forward Euler method,
#'   and \code{stream.L} and \code{stream.res} are used to compute the number of
#'   steps and the time interval between steps for the integration.
#'   \code{stream.width} is multiplied with \code{..step..} estimated by
#'   \code{\link[metR]{geom_streamline}} to control the width of streamlines.
#'   
#' @return A \code{ggplot2} object with the streamline plot.
#' 
#' @author Michael Stadler
#' 
#' @examples
#' library(scuttle)
#' set.seed(42)
#' sce1 <- mockSCE(ncells = 100, ngenes = 500)
#' sce2 <- mockSCE(ncells = 100, ngenes = 500)
#'
#' datlist <- list(X=counts(sce1), spliced=counts(sce1), unspliced=counts(sce2))
#'
#' out <- scvelo(datlist, mode = "dynamical")
#' 
#' em <- embedVelocity(reducedDim(out, 1), out)[,1:2]
#' 
#' # https://github.com/kevinrue/velociraptor/issues/90
#' 
#' if (!basilisk::isMacOSX()){
#'   plotVelocityStream(out, em)
#'   plotVelocityStream(out, em, color.streamlines = TRUE)
#' }
#' 
#' @seealso \code{\link{gridVectors}} used to summarize velocity vectors into
#'   a grid (velocity field), the \pkg{ggplot2} package used for plotting,
#'   \code{\link[metR]{geom_streamline}} in package \pkg{metR} used to
#'   calculate and add streamlines from the RNA velocity field to the plot,
#'   \code{\link[viridisLite]{viridis}} for creation of color palettes.
#' 
#' @export
#' @importFrom S4Vectors DataFrame
plotVelocityStream <- function(
    sce, embedded, use.dimred = 1,
  color_by = "#444444", color.alpha = 0.2,
  grid.resolution = 60, scale = TRUE,
  stream.L = 10, stream.min.L = 0, stream.res = 4,
  stream.width = 8,
  color.streamlines = FALSE,
  color.streamlines.map = c("#440154", "#482576", "#414487",
    "#35608D", "#2A788E", "#21908C",
    "#22A884", "#43BF71", "#7AD151",
    "#BBDF27", "#FDE725"),
  arrow.angle = 8, arrow.length = 0.8) {
  if (basilisk::isMacOSX()){ # both Intel and Arm
    warning(
      "This function has been observed to run indefinitely on macOS. ",
      "The issue is related to the metR::geom_streamline() layer but unsolved yet. ",
      "Use with caution and consider terminating R if rendering the plot freezes your session.",
      immediate. = TRUE
    )
  }
  
  if (!identical(ncol(sce), nrow(embedded))) {
    stop("'sce' and 'embedded' do not have consistent dimensions.")
  }
  if (is.numeric(use.dimred)) {
    stopifnot(exprs = {
      identical(length(use.dimred), 1L)
      use.dimred <= length(reducedDims(sce))
    })
    use.dimred <- reducedDimNames(sce)[use.dimred]
  }
  else if (is.character(use.dimred)) {
    stopifnot(exprs = {
      length(use.dimred) == 1L
      use.dimred %in% reducedDimNames(sce)
    })
  }
  else {
    stop("'use.dimred' is not a valid value for use in reducedDim(sce, use.dimred)")
  }
  if (!requireNamespace("ggplot2")) {
    stop("'plotVelocityStream' requires the package 'ggplot2'.")
  }
  
  # get coordinates in reduced dimensional space
  xy <- reducedDim(sce, use.dimred)[, 1:2]
  
  # summarize velocities in a grid
  gr <- gridVectors(x = xy, embedded = embedded,
    resolution = grid.resolution, scale = scale,
    as.data.frame = FALSE,
    return.intermediates = TRUE)
  
  # now make it a regular grid needed for metR::geom_streamline
  xbreaks <- seq(gr$limits[1,1], gr$limits[2,1], by = gr$delta[1])
  ybreaks <- seq(gr$limits[1,2], gr$limits[2,2], by = gr$delta[2])
  plotdat2 <- expand.grid(x = xbreaks + gr$delta[1] / 2,
    y = ybreaks + gr$delta[2] / 2,
    dx = 0, dy = 0)
  allcategories <- DataFrame(expand.grid(V1 = seq(0, grid.resolution),
    V2 = seq(0, grid.resolution)))
  ivec <- match(gr$categories[sort(unique(gr$grp)), ], allcategories)
  plotdat2[ivec, c("dx", "dy")] <- gr$vec
  
  
  # plot it using ggplot2 and metR::geom_streamline
  plotdat1 <- data.frame(xy)
  colnames(plotdat1) <- c("x", "y")
  if (is.character(color_by) && length(color_by) == 1L && color_by %in% colnames(colData(sce))) {
    plotdat1 <- cbind(plotdat1, col = colData(sce)[, color_by])
    colByFeat <- TRUE
  } else {
    colByFeat <- FALSE
  }
  p <- ggplot2::ggplot(plotdat1, ggplot2::aes(x = !!ggplot2::sym("x"), y = !!ggplot2::sym("y"))) +
    ggplot2::labs(x = paste(use.dimred, "1"), y = paste(use.dimred, "2"))
  if (!colByFeat) {
    colMatrix <- grDevices::col2rgb(col = color_by, alpha = TRUE)
    if (any(colMatrix[4, ] != 255)) {
      warning("ignoring 'color.alpha' as 'color_by' already specifies alpha channels")
      color.alpha <- colMatrix[4, ] / 255
    }
    p <- p + ggplot2::geom_point(color = color_by, alpha = color.alpha)
  } else {
    p <- p + ggplot2::geom_point(ggplot2::aes(color = !!ggplot2::sym("col")), alpha = color.alpha) +
      ggplot2::labs(color = color_by)
  }
  if (color.streamlines) {
    # remark: when coloring streamlines, we currently cannot have any arrows
    # remark: ..dx.., ..dy.. and ..step.. are calculated by metR::geom_streamline
    p <- p +
      metR::geom_streamline(
        mapping = ggplot2::aes(
          x = !!ggplot2::sym("x"),
          y = !!ggplot2::sym("y"),
          dx = !!ggplot2::sym("dx"),
          dy = !!ggplot2::sym("dy"),
          size = stream.width * !!ggplot2::sym("..step.."),
          alpha = !!ggplot2::sym("..step.."),
          color = ggplot2::stat(sqrt((!!ggplot2::sym("..dx.."))^2 +
              (!!ggplot2::sym("..dy.."))^2))),
        arrow = NULL, lineend = "round",
        data = plotdat2, size = 0.6, jitter = 2,
        L = stream.L, min.L = stream.min.L,
        res = stream.res, inherit.aes = FALSE) +
      ggplot2::scale_color_gradientn(colors = color.streamlines.map,
        guide = "none") +
      ggplot2::scale_alpha_continuous(guide = "none") +
      ggplot2::theme_minimal() +
      ggplot2::theme(axis.text = ggplot2::element_blank(),
        panel.grid.major = ggplot2::element_blank(),
        panel.grid.minor = ggplot2::element_blank())
  } else {
    p <- p +
      metR::geom_streamline(
        mapping = ggplot2::aes(
          x = !!ggplot2::sym("x"),
          y = !!ggplot2::sym("y"),
          dx = !!ggplot2::sym("dx"),
          dy = !!ggplot2::sym("dy"),
          size = stream.width * !!ggplot2::sym("..step..")),
        data = plotdat2, size = 0.3, jitter = 2,
        L = stream.L, min.L = stream.min.L,
        res = stream.res, arrow.angle = arrow.angle,
        arrow.length = arrow.length, inherit.aes = FALSE) +
      ggplot2::theme_minimal() +
      ggplot2::theme(axis.text = ggplot2::element_blank(),
        panel.grid.major = ggplot2::element_blank(),
        panel.grid.minor = ggplot2::element_blank())
  }
  
  return(p)
}

library(yaml)
yaml_data <- yaml::read_yaml("inst/envs/Linux_x86_64.yaml")
r_data <- gsub("([[:alnum:]_]+)=([[:alnum:].]+)=.+", "\\1==\\2" , yaml_data$dependencies)
cat(paste0(
  "c(",
  "\n",
  paste0("  ", "'", r_data, "'", collapse = ",\n"),
  "\n",
  ")",
  "\n"
))

#' RNA velocity with \pkg{scVelo}
#'
#' Perform RNA velocity calculations with the \pkg{scVelo} package.
#'
#' @param x A named list of three matrices of the same dimensions where genes are in rows and cells are in columns.
#' The list should contain \code{"spliced"} and \code{"unspliced"} entries containing spliced and unspliced counts, respectively.
#' It should also contain an \code{"X"} entry containing the \dQuote{usual} count matrix, see details below.
#'
#' Alternatively, a \linkS4class{SummarizedExperiment} object containing three such matrices among its assays.
#' @param ... For the generic, further arguments to pass to specific methods.
#' For the SummarizedExperiment and SingleCellExperiment methods, further arguments to pass to the ANY method.
#' @param assay.X An integer scalar or string specifying the assay of \code{x} containing the usual count matrix.
#' @param assay.spliced An integer scalar or string specifying the assay of \code{x} containing the spliced counts.
#' @param assay.unspliced An integer scalar or string specifying the assay of \code{x} containing the unspliced counts.
#' @param sf.X A numeric vector containing size factors for usual count matrix.
#' Defaults to \code{\link{librarySizeFactors}} on the \code{"X"} matrix in \code{x}.
#' @param sf.spliced A numeric vector containing size factors for the spliced counts for each cell.
#' Defaults to \code{\link{librarySizeFactors}} on the \code{"spliced"} matrix in \code{x}.
#' @param sf.unspliced A numeric vector containing size factors for the unspliced counts for each cell.
#' Defaults to \code{\link{librarySizeFactors}} on the \code{"unspliced"} matrix in \code{x}.
#' @param subset.row A character, integer or logical vector specifying the genes to use for the velocity calculations.
#' Defaults to all genes.
#' @param use.theirs Logical scalar indicating whether \pkg{scVelo}'s gene filtering and normalization should be used.
#' @param mode String specifying the method to use to estimate the transcriptional dynamics.
#' @param scvelo.params List of lists containing arguments for individual \pkg{scVelo} functions, see details below.
#' @param dimred A low-dimensional representation of the cells with number of rows equal to the number of cells in \code{x},
#' used to find the nearest neighbors.
#' @param use.dimred String naming the entry of \code{\link{reducedDims}(x)} to use for nearest neighbor calculations.
#' Ignored if \code{dimred} is supplied.
#' @param ncomponents Numeric scalar indicating the number of principal components to obtain.
#' Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.
#' @param BSPARAM A \linkS4class{BiocSingularParam} object specifying which algorithm should be used to perform the PCA.
#' Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.
#' @param BPPARAM A \linkS4class{BiocParallelParam} object specifying whether the PCA calculations should be parallelized.
#' Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.
#'
#' @details
#' This function uses the \pkg{scVelo} Python package (\url{https://pypi.org/project/scvelo/}) for RNA velocity calculations.
#' The main difference from the original \pkg{velocyto} approach is that the dynamical model of \pkg{scVelo}
#' does not rely on the presence of observed steady-state populations,
#' which should improve the reliability of the velocity calculations in general applications.
#'
#' For consistency with other Bioconductor workflows, we perform as many standard steps in R as we can
#' before starting the velocity calculations with \pkg{scVelo}.
#' This involves:
#' \enumerate{
#' \item Size factor-based normalization with \code{sf.*} values and \code{\link{normalizeCounts}}.
#' For \code{"X"}, log-transformation is performed as well, while for the others, only scaling normalization is performed.
#' \item Subsetting all matrices to \code{subset.row}, most typically to a subset of interest, e.g., highly variable genes.
#' Note that, if set, any subsetting is done \emph{after} normalization so that library sizes are correctly computed.
#' \item If \code{dimred=NULL}, the PCA step on the log-expression values derived from the \code{"X"} matrix,
#' using the specified \code{BSPARAM} to obtain the first \code{ncomponents} PCs.
#' }
#' This allows us to guarantee that, for example, the log-expression matrix of HVGs or the PCA coordinates
#' are the same as that used in other applications like clustering or trajectory reconstruction.
#'
#' Nonetheless, one can set \code{use.theirs=TRUE} to directly use the entire \pkg{scVelo} normalization and filtering pipeline.
#' This ignores all of the size factors arguments (\code{sf.*}),
#' all of the PCA-related arguments (\code{ncomponents}, \code{BSPARAM}) and \code{subset.row}.
#' However, if a low-dimensionality result is supplied via \code{dimred} or \code{use.dimred},
#' the \pkg{scVelo} PCA will always be omitted.
#'
#' Upon first use, this function will instantiate a conda environment containing the \pkg{scVelo} package.
#' This is done via the \pkg{basilisk} package - see the documentation for that package for trouble-shooting.
#'
#' @section Comments on the three matrices:
#' Strictly speaking, only the spliced and unspliced matrices are necessary for the velocity calculations.
#' However, it is often the case that the spliced matrix is not actually the same as a \dQuote{usual} count matrix
#' (e.g., generated by summing counts across all exons for all mapped genes).
#' This is due to differences in the handling of ambiguous reads that map across exon-intron boundaries,
#' or to genomic regions that can be either exonic or intronic depending on the isoform;
#' the spliced count matrix is more likely to exclude such reads.
#'
#' We request the usual count matrix as the \code{"X"} entry of \code{x} to ensure that
#' the PCA and nearest neighbor detection in \pkg{scVelo} are done on the same data
#' as that used in other steps of the large analysis (e.g., clustering, visualization, trajectory reconstruction).
#' In practice, if the usual count matrix is not available, one can often achieve satisfactory results
#' by simply re-using the spliced count matrix as both the \code{"X"} and \code{"spliced"} entries of \code{x}.
#'
#' Note that if reduced dimensions are supplied in \code{dimred},
#' any \code{"X"} entry is only used to create the AnnData object and is not used in any actual calculations.
#'
#' @section Additional arguments to Python:
#' Additional arguments to \pkg{scVelo} functions are provided via \code{scvelo.params}.
#' This is a named list where each entry is named after a function and is itself a named list of arguments for that function.
#' The following function names are currently recognized:
#' \itemize{
#' \item \code{"filter_and_normalize"}, for gene selection and normalization.
#' This is not used unless \code{use.theirs=TRUE}.
#' \item \code{"moments"}, for PCA and nearest neighbor detection.
#' The PCA is not performed if \code{dimred} or \code{use.dimred} is already supplied.
#' \item \code{"recover_dynamics"}
#' \item \code{"velocity"}
#' \item \code{"velocity_graph"}
#' \item \code{"velocity_pseudotime"}
#' \item \code{"latent_time"}
#' \item \code{"velocity_confidence"}
#' }
#' See the \pkg{scVelo} documentation for more details about the available arguments and the examples below for a syntax example.
#'
#' @section Supported operating systems and architectures:
#' \pkg{scVelo} dependencies are pinned in a Conda environment to ensure reproducibility.
#' 
#' Differences in packages and versions available from Conda require different environments for different operating systems and architectures.
#' \pkg{basilisk.utils} is used to determine the operating system and architecture of the computer used to run \code{scvelo()}, using to the appropriate Conda environment.
#' 
#' As of the latest \pkg{velociraptor} update (24 May 2024):
#' 
#' \describe{
#' \item{All environments}{
#' \pkg{tqdm} and \pkg{ipywidgets} are installed to suppress the message "Unable to create progress bar".
#' }
#' \item{Linux}{\pkg{scVelo} v0.3.2 from conda-forge is used.
#' This is the latest version available to date.
#' \pkg{libtiff} is pinned to v4.5.1 and \pkg{pillow} is pinned to v10.0.0 (\url{https://github.com/conda-forge/libtiff-feedstock/issues/104#issuecomment-2375893029}),
#' \pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
#' }
#' \item{Linux AArch64}{\pkg{scVelo} v0.3.2 from conda-forge is used.
#' This is the latest version available to date.
#' \pkg{libtiff} is pinned to v4.5.1 and \pkg{pillow} is pinned to v10.0.0 (\url{https://github.com/conda-forge/libtiff-feedstock/issues/104#issuecomment-2375893029}),
#' \pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
#' Please note that this environment has not been validated yet; it is derived from the environment from Linux (above) and requires additional testing to identify a working environment before pinning all the packages and versions in the environment.
#' }
#' \item{macOS}{\pkg{scVelo} v0.3.2 from conda-forge is used.
#' This is the latest version available to date.
#' \pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
#' }
#' \item{macOS ARM}{\pkg{scVelo} v0.3.2 from conda-forge is used.
#' This is the latest version available to date.
#' \pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
#' }
#' \item{Windows}{\pkg{scVelo} v0.2.5 from bioconda is used.
#' Later versions of \pkg{scVelo} depend on \pkg{jaxlib} which is not supported on Windows (\url{https://github.com/google/jax/issues/438}).
#' \pkg{matplotlib} is pinned to v3.6.3 (\url{https://github.com/scverse/scanpy/issues/2411}),
#' \pkg{pandas} is pinned to v1.5.2 (\url{https://stackoverflow.com/questions/76234312/importerror-cannot-import-name-is-categorical-from-pandas-api-types}),
#' and \pkg{numpy} is pinned to v1.21.1 (\url{https://github.com/theislab/scvelo/issues/1109}).
#' }
#' }
#'
#' @return
#' A \linkS4class{SingleCellExperiment} is returned containing the output of the velocity calculations.
#' Of particular interest are:
#' \itemize{
#' \item the \code{velocity_pseudotime} field in the \code{\link{colData}},
#' containing the velocity pseudotime for each cell.
#' \item the \code{velocity} entry of the \code{\link{assays}},
#' containing the velocity vectors for each cell.
#' }
#' The output will always have number of columns equal to the number of cells supplied in \code{x},
#' though the number of rows will depend on whether any subsetting (if \code{subset.row} is supplied)
#' or feature selection (if \code{use.theirs=TRUE}) was performed.
#'
#' @examples
#' # Using mock data to demonstrate the process:
#' library(scuttle)
#' sce1 <- mockSCE()
#' sce2 <- mockSCE()
#'
#' spliced <- counts(sce1)
#' unspliced <- counts(sce2)
#'
#' out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced))
#'
#' # make scvelo use 10 rather than the default 30 neighbors to compute moments for velocity estimation:
#' out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced),
#'               scvelo.params=list(neighbors=list(n_neighbors=10L)))
#'
#' @references
#' Bergen, V., Lange, M., Peidli, S. et al. Generalizing RNA velocity to transient cell states through dynamical modeling. Nat Biotechnol 38, 1408–1414 (2020). \url{https://doi.org/10.1038/s41587-020-0591-3}
#'
#' @author Aaron Lun, Charlotte Soneson, Kevin Rue-Albrecht
#' @name scvelo
NULL

#' @importFrom S4Vectors DataFrame
#' @importFrom scuttle normalizeCounts
#' @importFrom BiocSingular bsparam runPCA
#' @importFrom BiocParallel SerialParam
#' @importFrom Matrix t
#' @importFrom zellkonverter AnnData2SCE
.scvelo <- function(x, subset.row=NULL,
    sf.X=NULL, sf.spliced=NULL, sf.unspliced=NULL,
    use.theirs=FALSE,
    mode=c('steady_state', 'deterministic', 'stochastic', 'dynamical'),
    scvelo.params=list(), dimred=NULL, ncomponents=30, BPPARAM=SerialParam(),
    BSPARAM=bsparam())
{
    spliced <- x$spliced
    unspliced <- x$unspliced
    X <- x$X

    refdim <- as.integer(dim(spliced))
    if (!identical(refdim, as.integer(dim(unspliced))) || !identical(refdim, as.integer(dim(X)))) {
        stop("matrices in 'x' must have the same dimensions")
    }

    if (!use.theirs) {
        X <- normalizeCounts(X, sf.X, log=TRUE)
        spliced <- normalizeCounts(spliced, sf.spliced, log=FALSE)
        unspliced <- normalizeCounts(unspliced, sf.unspliced, log=FALSE)

        if (!is.null(subset.row)) {
            X <- X[subset.row,,drop=FALSE]
            spliced <- spliced[subset.row,,drop=FALSE]
            unspliced <- unspliced[subset.row,,drop=FALSE]
        }

        if (is.null(dimred)) {
            dimred <- runPCA(t(X), rank=ncomponents, BSPARAM=BSPARAM, BPPARAM=BPPARAM)$x
        }
    }

    mode <- match.arg(mode)
    output <- basiliskRun(env=velo.env, fun=.run_scvelo,
        X=X, spliced=spliced, unspliced=unspliced,
        use.theirs=use.theirs, mode=mode,
        scvelo.params=scvelo.params,
        dimred=dimred, testload = c("scvelo", "anndata"))

    output
}

.run_scvelo <- function(X, spliced, unspliced, use.theirs=FALSE, mode='dynamical', scvelo.params=list(), dimred=NULL) {
  
    # Check scvelo version
    # Less elegant but faster than `listPackages(velo.env)`
    scvelo_version <- package_version(gsub("scvelo==", "", grep("scvelo==", velo.env@packages, value = TRUE)))
    
    if (scvelo_version >= package_version("0.3.1")) {
      if (!is.null(scvelo.params$moments)) {
        if (!is.null(scvelo.params$moments$n_neighbors)) {
          stop(paste0(
            "scvelo.params$moments$n_neighbors is deprecated; use scvelo.params$neighbors$n_neighbors instead.","\n",
            "  See <https://github.com/theislab/scvelo/issues/1212#issuecomment-1979120563> for details."
          ))
        }
        if (!is.null(scvelo.params$moments$n_pcs)) {
          stop(paste0(
            "scvelo.params$moments$n_pcs is deprecated since scvelo==0.4.0; use scvelo.params$neighbors$n_pcs instead.","\n",
            "  See <https://github.com/theislab/scvelo/issues/1212#issuecomment-1979120563> for details."
          ))
        }
      } else {
        # if unspecified, set to NULL (= None)
        # see https://github.com/theislab/scvelo/issues/1212
        scvelo.params$moments <- list(
          n_neighbors = NULL,
          n_pcs = NULL
        )
      }
    }
    
    X <- t(velociraptor:::.make_np_friendly(X))
    spliced <- t(velociraptor:::.make_np_friendly(spliced))
    unspliced <- t(velociraptor:::.make_np_friendly(unspliced))

    and <- reticulate::import("anndata")
    scv <- reticulate::import("scvelo")
    sc <- reticulate::import("scanpy")
    adata <- and$AnnData(X, layers=list(spliced=spliced, unspliced=unspliced))
    adata$obs_names <- rownames(spliced)
    adata$var_names <- colnames(spliced)

    ## A supplied dimred will be used even if use.theirs=TRUE
    if (!is.null(dimred)) {
        dimred <- velociraptor:::.make_np_friendly(dimred)
        adata$obsm <- list(X_pca = dimred)
    }

    if (use.theirs) {
        do.call(scv$pp$filter_and_normalize, c(list(data=adata), scvelo.params$filter_and_normalize))
    }

    do.call(sc$pp$neighbors, c(list(adata), scvelo.params$neighbors))
    
    do.call(scv$pp$moments, c(list(data=adata), scvelo.params$moments))

    if (mode=="dynamical") {
        do.call(scv$tl$recover_dynamics, c(list(data=adata), scvelo.params$recover_dynamics))
    }

    scvelo.params$velocity$mode <- mode
    do.call(scv$tl$velocity, c(list(data=adata), scvelo.params$velocity))

    do.call(scv$tl$velocity_graph, c(list(data=adata), scvelo.params$velocity_graph))

    do.call(scv$tl$velocity_pseudotime, c(list(adata=adata), scvelo.params$velocity_pseudotime))

    if (mode=="dynamical") {
        do.call(scv$tl$latent_time, c(list(data=adata), scvelo.params$latent_time))
    }

    do.call(scv$tl$velocity_confidence, c(list(data=adata), scvelo.params$velocity_confidence))

    zellkonverter::AnnData2SCE(adata)
}

#' @export
#' @rdname scvelo
setGeneric("scvelo", function(x, ...) standardGeneric("scvelo"))

#' @export
#' @rdname scvelo
setMethod("scvelo", "ANY", .scvelo)

#' @export
#' @rdname scvelo
#' @importFrom BiocGenerics sizeFactors
setMethod("scvelo", "SummarizedExperiment", function(x, ...,
    assay.X="counts", assay.spliced="spliced", assay.unspliced="unspliced")
{
    .scvelo(list(X=assay(x, assay.X), spliced=assay(x, assay.spliced), unspliced=assay(x, assay.unspliced)), ...)
})

#' @export
#' @rdname scvelo
#' @importFrom BiocGenerics sizeFactors
#' @importFrom SingleCellExperiment reducedDimNames reducedDim
setMethod("scvelo", "SingleCellExperiment", function(x, ..., sf.X=sizeFactors(x), dimred=NULL, use.dimred=NULL) {
    if (is.null(dimred)) {
        if (!is.null(use.dimred)) {
            dimred <- reducedDim(x, use.dimred)
        }
    }
    callNextMethod(x, ..., sf.X=sf.X, dimred=dimred)
})

# This tests for the correct function of the scvelo function.
# library(testthat); library(velociraptor); source("test-scvelo.R")

library(scuttle)
sce1 <- mockSCE()
sce2 <- mockSCE()

spliced <- counts(sce1)
unspliced <- counts(sce2)

set.seed(100001)
test_that("scvelo works as expected with vanilla settings", {
    out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced))
    expect_identical(rownames(out), rownames(spliced))
    expect_identical(colnames(out), colnames(spliced))
    expect_true("velocity" %in% assayNames(out))
    expect_true("velocity_pseudotime" %in% colnames(colData(out)))

    # Throwing in some subsetting.
    subset.row <- c(50:1, 100:200)
    out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced), subset.row=subset.row)
    expect_identical(rownames(out), rownames(spliced)[subset.row])
    expect_identical(colnames(out), colnames(spliced))
    expect_true("velocity" %in% assayNames(out))
    expect_true("velocity_pseudotime" %in% colnames(colData(out)))

    # Check that the errors break.
    expect_error(scvelo(list(X=spliced[1:10,], spliced=spliced, unspliced=unspliced)), "same dimensions") 
})

set.seed(100002)
test_that("scvelo is agnostic to X when we override the dimensionality reduction", {
    dimred <- matrix(rnorm(10000), nrow=ncol(spliced))

    set.seed(0)
    ref <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced), dimred=dimred)

    set.seed(0)
    spliced2 <- spliced
    spliced2[] <- 0
    alt <- scvelo(list(X=spliced2, spliced=spliced, unspliced=unspliced), sf.X=rep(1, ncol(spliced2)), dimred=dimred)

    # TODO: find and kill that random seed!
    expect_equal(alt$velocity_pseudotime, ref$velocity_pseudotime, tol=1e-5)
})

set.seed(100003)
test_that("scvelo works correctly with SE inputs", {
    sce <- SingleCellExperiment(list(spliced=counts(sce1), unspliced=counts(sce2)))

    set.seed(0)
    ref <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced))
    set.seed(0)
    alt <- scvelo(sce, assay.X="spliced")
    expect_equal(alt$velocity_pseudotime, ref$velocity_pseudotime, tol=1e-5)

    # Behaves properly with dimreds.
    dimred <- matrix(rnorm(10000), nrow=ncol(spliced))

    set.seed(0)
    ref <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced), dimred=dimred)
    set.seed(0)
    reducedDim(sce, "PCA") <- dimred
    alt <- scvelo(sce, assay.X="spliced", use.dimred="PCA")
    expect_equal(alt$velocity_pseudotime, ref$velocity_pseudotime, tol=1e-5)
})

set.seed(100004)
test_that("scvelo works correctly with their pipeline", {
    ref <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced), use.theirs=TRUE)
    expect_s4_class(ref, "SingleCellExperiment")
})

# This tests the embedding functionality.
# library(testthat); library(velociraptor); source("test-embed.R")

library(scuttle)
sce1 <- mockSCE()
sce2 <- mockSCE()

spliced <- counts(sce1)
unspliced <- counts(sce2)

set.seed(100001)
out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced))

test_that("embedVelocity works correctly", {
    tsne.results <- matrix(rnorm(2*ncol(out)), ncol=2)
    projected <- embedVelocity(tsne.results, out)
    expect_identical(dim(tsne.results), dim(projected))

    # Same results inside an SCE.
    reducedDim(sce1, "TSNE") <- tsne.results
    projected2 <- embedVelocity(sce1, out, use.dimred="TSNE")
    expect_identical(projected, projected2)
})

test_that("gridVectors works correctly", {
    tsne.results <- matrix(rnorm(2*ncol(out)), ncol=2)
    projected <- embedVelocity(tsne.results, out)

    out <- gridVectors(tsne.results, projected)
    expect_identical(ncol(out), 4L)

    expect_warning(out <- gridVectors(tsne.results, projected, return.intermediates=TRUE))
    expect_type(out, "list")
    expect_length(out, 7L)
    
    out <- gridVectors(tsne.results, projected, as.data.frame=FALSE)
    expect_type(out, "list")

    # Same results inside an SCE.
    reducedDim(sce1, "TSNE") <- tsne.results
    out2 <- gridVectors(sce1, projected, use.dimred="TSNE", as.data.frame=FALSE)
    expect_identical(out, out2)
})

---
title: "velociraptor sanity check"
date: "`r Sys.Date()`"
output: 
  html_document:
    toc: true
editor_options: 
  chunk_output_type: console
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Load packages

```{r}
suppressPackageStartupMessages({
    library(scRNAseq)
    library(scuttle)
    library(scran)
    library(velociraptor)
    library(scater)
    library(cowplot)
    library(GGally)
    library(reticulate)
    library(SingleCellExperiment)
    library(basilisk)
})
```

# Define virtual environment to use for reticulate

We use the `velociraptor` conda environment in order to run the scVelo commands also directly in python.

```{r}
reticulate::use_virtualenv(basilisk:::.obtainEnvironmentPath(velociraptor:::velo.env))
sys <- reticulate::import("sys")
sys$version
```

# Set temporary directory

Output objects (to move data from SCE to AnnData without using basilisk) are saved to a temporary directory.

```{r}
tmpdir <- tempdir()
```

# Prepare data

We use an example data set from `scRNAseq`, and subset to the first 500 cells. 
Next, we preprocess the data set by selecting highly variable genes and applying PCA and tSNE.
The object is also saved to a h5ad file for use with scVelo directly in python.

```{r}
## Load and subset data
sce <- scRNAseq::HermannSpermatogenesisData()[, 1:500]

## Add 'counts' assay
assay(sce, "counts") <- assay(sce, "spliced")

## Save to h5ad file for python scVelo analysis
zellkonverter::writeH5AD(sce, X_name = "counts", 
                         file=file.path(tmpdir, "anndata.h5ad"))
```

# Run analysis directly in python

We use the same conda environment as in `velociraptor` to run the scVelo analysis directly in python, rather than via the R wrapper. 

## Steady-state model

```{python}
import scanpy as sc
import sys
import numpy as np
import anndata
import scvelo as scv
import matplotlib
import pandas as pd
from pathlib import Path
from os import path
adata=anndata.read(r.tmpdir + "/anndata.h5ad")
scv.pp.filter_and_normalize(adata, enforce=True, n_top_genes=2000)
scv.pp.moments(adata)
scv.tl.velocity(adata, mode="steady_state")
scv.tl.velocity_graph(adata)
scv.tl.velocity_pseudotime(adata)
scv.tl.velocity_confidence(adata)
adata.write(r.tmpdir + "/anndata_withvelo_steadystate.h5ad")
```

## Dynamical model

```{python}
import scanpy as sc
import sys
import numpy as np
import anndata
import scvelo as scv
import matplotlib
import pandas as pd
adata=anndata.read(r.tmpdir + "/anndata.h5ad")
scv.pp.filter_and_normalize(adata, enforce=True, n_top_genes=2000)
scv.pp.moments(adata)
scv.tl.recover_dynamics(adata)
scv.tl.velocity(adata, mode="dynamical")
scv.tl.velocity_graph(adata)
scv.tl.velocity_pseudotime(adata)
scv.tl.latent_time(adata)
scv.tl.velocity_confidence(adata)
adata.write(r.tmpdir + "/anndata_withvelo_dynamical.h5ad")
```

## Read back objects in R for later comparison

```{r}
sceps <- zellkonverter::readH5AD(file.path(tmpdir, "anndata_withvelo_steadystate.h5ad"))
scepd <- zellkonverter::readH5AD(file.path(tmpdir, "anndata_withvelo_dynamical.h5ad"))
```

# Process the data set

```{r}
sce <- scuttle::logNormCounts(sce, assay.type=1)

## To use the HVGs determined by scVelo
# top.hvgs <- rownames(sceps)

## To get HVGs with scran
dec <- scran::modelGeneVar(sce)
top.hvgs <- scran::getTopHVGs(dec, n=2000)

set.seed(1)
sce <- scater::runPCA(sce, subset_row=top.hvgs)
sce <- scater::runTSNE(sce, dimred="PCA")
```

# Helper function

The function below runs scVelo via the R wrapper, first using the pre-normalized data and PCA from the SingleCellExperiment object, and then with `use_theirs=TRUE`. 
It also performs some comparisons between the two results. 

```{r}
run_scv <- function(sce, top.hvgs, mode) {
    ## precomputed PCs and normalized values
    velo.out <- scvelo(
        sce, assay.X="counts", sf.X=sizeFactors(sce), 
        subset.row=top.hvgs, use.dimred="PCA",
        mode=mode
    )
    stopifnot(colnames(sce) == colnames(velo.out))
    sce$velocity_pseudotime <- velo.out$velocity_pseudotime
    
    ## using scVelo normalization, gene selection and PCA calculation
    velo.out_theirs <- scvelo(
        sce, assay.X="counts", use.theirs=TRUE, mode=mode,
        scvelo.params=list(filter_and_normalize=list(enforce=TRUE, 
                                                     n_top_genes=2000L))
    )
    stopifnot(colnames(sce) == colnames(velo.out_theirs))
    sce$velocity_pseudotime_theirs <- velo.out_theirs$velocity_pseudotime

    ## Inferred pseudotime
    print(cowplot::plot_grid(
        cowplot::plot_grid(
            plotTSNE(sce, colour_by="velocity_pseudotime"),
            plotTSNE(sce, colour_by="velocity_pseudotime_theirs"),
            nrow = 1),
        plotTSNE(sce, colour_by="celltype"), ncol = 1
    ))
    print(GGally::ggpairs(as.data.frame(colData(sce))[, c("velocity_pseudotime", 
                                                          "velocity_pseudotime_theirs")]))

    shared_genes <- Reduce(intersect, list(rownames(velo.out), rownames(velo.out_theirs)))
    message("Number of shared genes:")
    print(length(shared_genes))
    message("Ours:")
    print(table(shared = rownames(velo.out) %in% shared_genes,
                velogene = rowData(velo.out)$velocity_genes))
    message("Theirs:")
    print(table(shared = rownames(velo.out_theirs) %in% shared_genes,
                velogene = rowData(velo.out_theirs)$velocity_genes))
    message("Among shared genes, how many are velocity genes:")
    print(table(ours = rowData(velo.out[shared_genes, ])$velocity_genes,
                theirs = rowData(velo.out_theirs[shared_genes, ])$velocity_genes))
    
    ## Correlations of velocities
    velo_corrs <- diag(cor(assay(velo.out[shared_genes, ], "velocity"), 
                           assay(velo.out_theirs[shared_genes, colnames(velo.out)],
                                 "velocity"),
                           use = "pairwise.complete"))
    hist(velo_corrs, 100)
    
    ## Correlations of normalized spliced/unspliced values
    ms_corrs <- diag(cor(assay(velo.out[shared_genes, ], "Ms"), 
                         assay(velo.out_theirs[shared_genes, colnames(velo.out)],
                               "Ms"),
                         use = "pairwise.complete"))
    hist(ms_corrs, 100)
    mu_corrs <- diag(cor(assay(velo.out[shared_genes, ], "Mu"), 
                         assay(velo.out_theirs[shared_genes, colnames(velo.out)],
                               "Mu"),
                         use = "pairwise.complete"))
    hist(mu_corrs, 100)
    
    velo.out_theirs
}
```

# Run scVelo

## Dynamical model

```{r, fig.width = 8}
sced <- run_scv(sce, top.hvgs=top.hvgs, mode="dynamical")
```

### Compare our run with 'use_theirs=TRUE' to direct python calls

```{r}
stopifnot(all(colnames(sced) == colnames(scepd)),
          all(rownames(sced) == rownames(scepd)))
## Correlations of velocities
velo_corrs <- diag(cor(assay(sced, "velocity"), 
                       assay(scepd, "velocity"),
                       use = "pairwise.complete"))
summary(velo_corrs)
plot(sced$velocity_pseudotime, scepd$velocity_pseudotime)
summary(abs(sced$velocity_pseudotime - scepd$velocity_pseudotime))
stopifnot(max(abs(sced$velocity_pseudotime - scepd$velocity_pseudotime)) < 1e-3)
```

## Steady-state model

```{r, fig.width = 8}
sces <- run_scv(sce, top.hvgs=top.hvgs, mode="steady_state")
```

### Compare our run with 'use_theirs=TRUE' to direct python calls

```{r}
stopifnot(all(colnames(sces) == colnames(sceps)),
          all(rownames(sces) == rownames(sceps)))
## Correlations of velocities
velo_corrs <- diag(cor(assay(sces, "velocity"), 
                       assay(sceps, "velocity"),
                       use = "pairwise.complete"))
summary(velo_corrs)
plot(sces$velocity_pseudotime, sceps$velocity_pseudotime)
summary(abs(sces$velocity_pseudotime - sceps$velocity_pseudotime))
stopifnot(max(abs(sces$velocity_pseudotime - sceps$velocity_pseudotime)) < 1e-3)
```


# Session info

```{r}
sessionInfo()
```

---
title: Computing RNA velocity in a Bioconductor framework
author:
- name: Kevin Rue-Albrecht
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
- name: Charlotte Soneson
  email: charlottesoneson@gmail.com
package: velociraptor
bibliography: velociraptor.bib
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{User's guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}    
---

```{r, echo=FALSE, results="hide", message=FALSE}
require(knitr)
library(BiocStyle)
opts_chunk$set(error=FALSE, message=FALSE, warning=FALSE)
```

# Overview

This package provides a lightweight interface between the Bioconductor `SingleCellExperiment` data structure
and the `r basilisk::PyPiLink("scvelo")` Python package for RNA velocity calculations.
The interface is comparable to that of many other `SingleCellExperiment`-compatible functions,
allowing users to plug in RNA velocity calculations into the existing Bioconductor analysis framework.
To demonstrate, we will use a data set from @Hermann2018-spermatogenesis, provided via the `r Biocpkg("scRNAseq")` package.
This data set contains gene-wise estimates of spliced and unspliced UMI counts for 2,325 mouse spermatogenic cells.

```{r}
library(scRNAseq)
sce <- HermannSpermatogenesisData()
sce
```

# Downsampling for demonstration

The full data set requires up to 12 GB of memory for the example usage presented in this vignette.
For demonstration purposes, we downsample the data set to the first 500 cells.
Feel free to skip this downsampling step if you have access to sufficient memory.

```{r}
sce <- sce[, 1:500]
```

# Basic workflow

We assume that feature selection has already been performed by the user using any method 
(see [here](https://osca.bioconductor.org/feature-selection.html) for some suggestions).
In this case, we will use the variance of log-expressions from `r Biocpkg("scran")` to select the top 2000 genes.

```{r}
library(scuttle)
sce <- logNormCounts(sce, assay.type=1)

library(scran)
dec <- modelGeneVar(sce)
top.hvgs <- getTopHVGs(dec, n=2000)
```

We can plug these choices into the `scvelo()` function with our `SingleCellExperiment` object.
By default, `scvelo()` uses the steady-state approach to estimate velocities,
though the stochastic and dynamical models implemented in `r basilisk::PyPiLink("scvelo")` can also be used by modifying the `mode` argument.

Note that automatic neighbor calculation is deprecated since scvelo==0.4.0 and will be removed in a future version.
Instead, `r BiocStyle::Biocpkg("velociraptor")` computes neighbors with Scanpy (as per [scVelo recommendations](https://github.com/theislab/scvelo/blob/f21651c3b122860d8ae6b5a5173f242ba91c8761/scvelo/preprocessing/moments.py#L66)), and the number of neighbors should be supplied to [scanpy.pp.neighbors](https://scanpy.readthedocs.io/en/stable/api/generated/scanpy.pp.neighbors.html) as demonstrated below.

In particular, the default number of neighbors was 30 for [scvelo.pp.moments](https://scvelo.readthedocs.io/en/stable/scvelo.pp.moments.html) while it is 15 for [scanpy.pp.neighbors](https://scanpy.readthedocs.io/en/stable/api/generated/scanpy.pp.neighbors.html).
Users should use `scvelo.params=list(neighbors=list(n_neighbors=30L)` to reproduce earlier results.

```{r}
library(velociraptor)
velo.out <- scvelo(
  sce, subset.row=top.hvgs, assay.X="spliced",
  scvelo.params=list(neighbors=list(n_neighbors=30L))
)
velo.out
```

In the above call, we use the `"spliced"` count matrix as a proxy for the typical exonic count matrix.
Technically, the latter is not required for the velocity estimation, but `r basilisk::PyPiLink("scvelo")` needs to perform a PCA and nearest neighbors search,
and we want to ensure that the neighbors detected inside the function are consistent with the rest of the analysis workflow (performed on the exonic counts).
There are some subtle differences between the spliced count matrix and the typical exonic count matrix - see `?scvelo` for some commentary about this -
but the spliced counts are generally a satisfactory replacement if the latter is not available.

The `scvelo()` function produces a `SingleCellExperiment` containing all of the outputs of the calculation in Python.
Of particular interest is the `velocity_pseudotime` vector that captures the relative progression of each cell 
along the biological process driving the velocity vectors.
We can visualize this effect below in a $t$-SNE plot generated by `r Biocpkg('scater')` on the top HVGs.

```{r}
library(scater)

set.seed(100)
sce <- runPCA(sce, subset_row=top.hvgs)
sce <- runTSNE(sce, dimred="PCA", perplexity = 30)

sce$velocity_pseudotime <- velo.out$velocity_pseudotime
plotTSNE(sce, colour_by="velocity_pseudotime")
```

It is also straightforward to embed the velocity vectors into our desired low-dimensional space, 
as shown below for the $t$-SNE coordinates.
This uses a grid-based approach to summarize the per-cell vectors into local representatives for effective visualization.

```{r}
embedded <- embedVelocity(reducedDim(sce, "TSNE"), velo.out)
grid.df <- gridVectors(sce, embedded, use.dimred = "TSNE")

library(ggplot2)
plotTSNE(sce, colour_by="velocity_pseudotime") +
    geom_segment(data=grid.df, mapping=aes(x=start.1, y=start.2, 
        xend=end.1, yend=end.2, colour=NULL), arrow=arrow(length=unit(0.05, "inches")))
```

And that's it, really.

# Advanced options

`scvelo()` interally performs a PCA step that we can bypass by supplying our own PC coordinates.
Indeed, it is often the case that we have already performed PCA in the earlier analysis steps,
so we can just re-use those results to (i) save time and (ii) improve consistency with the other steps.
Here, we computed the PCA coordinates in `runPCA()` above, so let's just recycle that:

```{r}
# Only setting assay.X= for the initial AnnData creation,
# it is not actually used in any further steps.
velo.out2 <- scvelo(sce, assay.X=1, subset.row=top.hvgs, use.dimred="PCA") 
velo.out2
```

We also provide an option to use the `r basilisk::PyPiLink("scvelo")` pipeline without modification,
i.e., relying on their normalization and feature selection.
This sacrifices consistency with other Bioconductor workflows but enables perfect mimicry of a pure Python-based analysis. 
In this case, arguments like `subset.row=` are simply ignored. 

```{r}
velo.out3 <- scvelo(sce, assay.X=1, use.theirs=TRUE)
velo.out3
```

Advanced users can tinker with the settings of individual `r basilisk::PyPiLink("scvelo")` steps
by setting named lists of arguments in the `scvelo.params=` argument.
For example, to tinker with the behavior of the `recover_dynamics` step, we could do:

```{r}
velo.out4 <- scvelo(sce, assay.X=1, subset.row=top.hvgs,
    scvelo.params=list(recover_dynamics=list(max_iter=20)))
velo.out4
```

# Session information

```{r}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gridVectors.R
\name{gridVectors}
\alias{gridVectors}
\alias{gridVectors,ANY-method}
\alias{gridVectors,SingleCellExperiment-method}
\title{Summarize vectors into a grid}
\usage{
gridVectors(x, embedded, ...)

\S4method{gridVectors}{ANY}(
  x,
  embedded,
  resolution = 40,
  scale = TRUE,
  as.data.frame = TRUE,
  return.intermediates = FALSE
)

\S4method{gridVectors}{SingleCellExperiment}(x, embedded, ..., use.dimred = 1)
}
\arguments{
\item{x}{A numeric matrix of low-dimensional coordinates, e.g., after t-SNE.
Alternatively, a \linkS4class{SingleCellExperiment} containing such coordinates in its \code{\link{reducedDims}}.}

\item{embedded}{A low-dimensional projection of the velocity vectors into the embedding of \code{x}.
This should be of the same dimensions as \code{x} and is typically produced by \code{\link{embedVelocity}}.}

\item{...}{For the generic, further arguments to pass to specific methods.

For the SingleCellExperiment method, further arguments to pass to the ANY method.}

\item{resolution}{Integer scalar specifying the resolution of the grid,
in terms of the number of grid intervals along each axis.}

\item{scale}{Logical scalar indicating whether the averaged vectors should be scaled by the grid resolution.}

\item{as.data.frame}{Logical scalar indicating whether the output should be a data.frame.
If \code{FALSE}, a list of two matrices is returned.}

\item{return.intermediates}{Logical scalar indicating whether intermediate objects should also be returned.
This enforces \code{as.data.frame=FALSE} and throws a warning if it is \code{TRUE}.}

\item{use.dimred}{String or integer scalar specifying the reduced dimensions to retrieve from \code{x}.}
}
\value{
If \code{as.data.frame=FALSE}, a list is returned containing \code{start} and \code{end},
two numeric matrices with one row per non-empty block in the grid and one column per column in \code{x}.
\code{start} contains the mean location of all cells inside that block,
and \code{end} contains the endpoint after adding the (scaled) average of the block's cell's velocity vectors.

If \code{as.data.frame=TRUE}, a data.frame is returned with numeric columns of the same contents as the list above.
Column names are prefixed by \code{start.*} and \code{end.*}.

If \code{return.intermediates=TRUE}, a list is returned (irrespective of the value of \code{as.data.frame})
that in addition to \code{start} and \code{end} also contains intermediate objects \code{limits}
(the ranges in x and y), \code{delta} (the grid intervals in x and y), \code{categories} (a
DataFrame with integer row and column indices for each cell that specify the grid field that it is
contained in), \code{grp} (numerical index of grid fields for each cell) and \code{vec} (velocity
vectors for non-empty grid fields).
}
\description{
Summarize the velocity vectors into a grid, usually for easy plotting.
}
\details{
This partitions the bounding box of \code{x} into a grid with \code{resolution} units in each dimension.
The locations and vectors of all cells in each block are averaged to obtain a representative of that block.
This is most obviously useful for visualization to avoid overplotting of velocity vectors.

If \code{scale=TRUE}, per-block vectors are scaled so that the median vector length is comparable to the spacing between blocks.
This improves visualization when the scales of \code{x} and \code{embedded} are not immediately comparable.
}
\examples{
tsne.results <- matrix(rnorm(10000), ncol=2)
tsne.vectors <- matrix(rnorm(10000), ncol=2)

out <- gridVectors(tsne.results, tsne.vectors)

# Demonstration for plotting.
plot(tsne.results[,1], tsne.results[,2], col='grey')
arrows(out$start.1, out$start.2, out$end.1, out$end.2, length=0.05)

}
\seealso{
\code{\link{embedVelocity}}, to generate \code{embedded}.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/embedVelocity.R
\name{embedVelocity}
\alias{embedVelocity}
\alias{embedVelocity,ANY-method}
\alias{embedVelocity,SingleCellExperiment-method}
\title{Project velocities onto an embedding}
\usage{
embedVelocity(x, vobj, ...)

\S4method{embedVelocity}{ANY}(x, vobj, ...)

\S4method{embedVelocity}{SingleCellExperiment}(x, vobj, ..., use.dimred = 1)
}
\arguments{
\item{x}{A numeric matrix of low-dimensional coordinates, e.g., after t-SNE.
Alternatively, a \linkS4class{SingleCellExperiment} containing such coordinates in its \code{\link{reducedDims}}.}

\item{vobj}{A \linkS4class{SingleCellExperiment} containing the output of the velocity calculations,
typically after running \code{\link{scvelo}}.}

\item{...}{For the generic, further arguments to pass to specific methods.

For the ANY method, further arguments to pass to the \code{velocity_embedding} Python function from \pkg{scVelo}.

For the SingleCellExperiment method, further arguments to pass to the ANY method.}

\item{use.dimred}{String or integer scalar specifying the reduced dimensions to retrieve from \code{x}.}
}
\value{
A numeric matrix of the same dimensions as \code{x}, containing the projected velocity vectors in that embedding.
}
\description{
Project the velocity vector for each cell onto an existing low-dimensional embedding.
}
\details{
This is a simple wrapper around the \code{scvelo.tools.velocity_embedding} function.
Briefly, we construct a cell-cell transition matrix where a cell is more likely to transition to one of its neighbors
if its velocity vector is pointing in the same direction as that neighbor.
The resulting matrix is then used to compute a weighted average of the positions in \code{x},
allowing us to compute a velocity in the low-dimensional embedding.
}
\examples{
example(scvelo, echo=FALSE) # recycling that example.

# Making up a new embedding.
tsne.results <- matrix(rnorm(2*ncol(out)), ncol=2)

# Projecting the future state of each cell:
projected <- embedVelocity(tsne.results, out)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/velociraptor-package.R
\docType{package}
\name{velociraptor-package}
\alias{velociraptor}
\alias{velociraptor-package}
\title{velociraptor: Toolkit for Single-Cell Velocity}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

This package provides Bioconductor-friendly wrappers for RNA velocity calculations in single-cell RNA-seq data. We use the basilisk package to manage Conda environments, and the zellkonverter package to convert data structures between SingleCellExperiment (R) and AnnData (Python). The information produced by the velocity methods is stored in the various components of the SingleCellExperiment class.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/kevinrue/velociraptor}
  \item Report bugs at \url{https://github.com/kevinrue/velociraptor/issues}
}

}
\author{
\strong{Maintainer}: Kevin Rue-Albrecht \email{kevinrue67@gmail.com} (\href{https://orcid.org/0000-0003-3899-3872}{ORCID})

Authors:
\itemize{
  \item Aaron Lun \email{infinite.monkeys.with.keyboards@gmail.com} (\href{https://orcid.org/0000-0002-3564-4813}{ORCID})
  \item Charlotte Soneson \email{charlottesoneson@gmail.com} (\href{https://orcid.org/0000-0003-3833-2169}{ORCID})
  \item Michael Stadler \email{michael.stadler@fmi.ch} (\href{https://orcid.org/0000-0002-2269-4934}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scvelo.R
\name{scvelo}
\alias{scvelo}
\alias{scvelo,ANY-method}
\alias{scvelo,SummarizedExperiment-method}
\alias{scvelo,SingleCellExperiment-method}
\title{RNA velocity with \pkg{scVelo}}
\usage{
scvelo(x, ...)

\S4method{scvelo}{ANY}(
  x,
  subset.row = NULL,
  sf.X = NULL,
  sf.spliced = NULL,
  sf.unspliced = NULL,
  use.theirs = FALSE,
  mode = c("steady_state", "deterministic", "stochastic", "dynamical"),
  scvelo.params = list(),
  dimred = NULL,
  ncomponents = 30,
  BPPARAM = SerialParam(),
  BSPARAM = bsparam()
)

\S4method{scvelo}{SummarizedExperiment}(
  x,
  ...,
  assay.X = "counts",
  assay.spliced = "spliced",
  assay.unspliced = "unspliced"
)

\S4method{scvelo}{SingleCellExperiment}(x, ..., sf.X = sizeFactors(x), dimred = NULL, use.dimred = NULL)
}
\arguments{
\item{x}{A named list of three matrices of the same dimensions where genes are in rows and cells are in columns.
The list should contain \code{"spliced"} and \code{"unspliced"} entries containing spliced and unspliced counts, respectively.
It should also contain an \code{"X"} entry containing the \dQuote{usual} count matrix, see details below.

Alternatively, a \linkS4class{SummarizedExperiment} object containing three such matrices among its assays.}

\item{...}{For the generic, further arguments to pass to specific methods.
For the SummarizedExperiment and SingleCellExperiment methods, further arguments to pass to the ANY method.}

\item{subset.row}{A character, integer or logical vector specifying the genes to use for the velocity calculations.
Defaults to all genes.}

\item{sf.X}{A numeric vector containing size factors for usual count matrix.
Defaults to \code{\link{librarySizeFactors}} on the \code{"X"} matrix in \code{x}.}

\item{sf.spliced}{A numeric vector containing size factors for the spliced counts for each cell.
Defaults to \code{\link{librarySizeFactors}} on the \code{"spliced"} matrix in \code{x}.}

\item{sf.unspliced}{A numeric vector containing size factors for the unspliced counts for each cell.
Defaults to \code{\link{librarySizeFactors}} on the \code{"unspliced"} matrix in \code{x}.}

\item{use.theirs}{Logical scalar indicating whether \pkg{scVelo}'s gene filtering and normalization should be used.}

\item{mode}{String specifying the method to use to estimate the transcriptional dynamics.}

\item{scvelo.params}{List of lists containing arguments for individual \pkg{scVelo} functions, see details below.}

\item{dimred}{A low-dimensional representation of the cells with number of rows equal to the number of cells in \code{x},
used to find the nearest neighbors.}

\item{ncomponents}{Numeric scalar indicating the number of principal components to obtain.
Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.}

\item{BPPARAM}{A \linkS4class{BiocParallelParam} object specifying whether the PCA calculations should be parallelized.
Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.}

\item{BSPARAM}{A \linkS4class{BiocSingularParam} object specifying which algorithm should be used to perform the PCA.
Only used if \code{use.theirs=FALSE} and \code{dimred=NULL}.}

\item{assay.X}{An integer scalar or string specifying the assay of \code{x} containing the usual count matrix.}

\item{assay.spliced}{An integer scalar or string specifying the assay of \code{x} containing the spliced counts.}

\item{assay.unspliced}{An integer scalar or string specifying the assay of \code{x} containing the unspliced counts.}

\item{use.dimred}{String naming the entry of \code{\link{reducedDims}(x)} to use for nearest neighbor calculations.
Ignored if \code{dimred} is supplied.}
}
\value{
A \linkS4class{SingleCellExperiment} is returned containing the output of the velocity calculations.
Of particular interest are:
\itemize{
\item the \code{velocity_pseudotime} field in the \code{\link{colData}},
containing the velocity pseudotime for each cell.
\item the \code{velocity} entry of the \code{\link{assays}},
containing the velocity vectors for each cell.
}
The output will always have number of columns equal to the number of cells supplied in \code{x},
though the number of rows will depend on whether any subsetting (if \code{subset.row} is supplied)
or feature selection (if \code{use.theirs=TRUE}) was performed.
}
\description{
Perform RNA velocity calculations with the \pkg{scVelo} package.
}
\details{
This function uses the \pkg{scVelo} Python package (\url{https://pypi.org/project/scvelo/}) for RNA velocity calculations.
The main difference from the original \pkg{velocyto} approach is that the dynamical model of \pkg{scVelo}
does not rely on the presence of observed steady-state populations,
which should improve the reliability of the velocity calculations in general applications.

For consistency with other Bioconductor workflows, we perform as many standard steps in R as we can
before starting the velocity calculations with \pkg{scVelo}.
This involves:
\enumerate{
\item Size factor-based normalization with \code{sf.*} values and \code{\link{normalizeCounts}}.
For \code{"X"}, log-transformation is performed as well, while for the others, only scaling normalization is performed.
\item Subsetting all matrices to \code{subset.row}, most typically to a subset of interest, e.g., highly variable genes.
Note that, if set, any subsetting is done \emph{after} normalization so that library sizes are correctly computed.
\item If \code{dimred=NULL}, the PCA step on the log-expression values derived from the \code{"X"} matrix,
using the specified \code{BSPARAM} to obtain the first \code{ncomponents} PCs.
}
This allows us to guarantee that, for example, the log-expression matrix of HVGs or the PCA coordinates
are the same as that used in other applications like clustering or trajectory reconstruction.

Nonetheless, one can set \code{use.theirs=TRUE} to directly use the entire \pkg{scVelo} normalization and filtering pipeline.
This ignores all of the size factors arguments (\code{sf.*}),
all of the PCA-related arguments (\code{ncomponents}, \code{BSPARAM}) and \code{subset.row}.
However, if a low-dimensionality result is supplied via \code{dimred} or \code{use.dimred},
the \pkg{scVelo} PCA will always be omitted.

Upon first use, this function will instantiate a conda environment containing the \pkg{scVelo} package.
This is done via the \pkg{basilisk} package - see the documentation for that package for trouble-shooting.
}
\section{Comments on the three matrices}{

Strictly speaking, only the spliced and unspliced matrices are necessary for the velocity calculations.
However, it is often the case that the spliced matrix is not actually the same as a \dQuote{usual} count matrix
(e.g., generated by summing counts across all exons for all mapped genes).
This is due to differences in the handling of ambiguous reads that map across exon-intron boundaries,
or to genomic regions that can be either exonic or intronic depending on the isoform;
the spliced count matrix is more likely to exclude such reads.

We request the usual count matrix as the \code{"X"} entry of \code{x} to ensure that
the PCA and nearest neighbor detection in \pkg{scVelo} are done on the same data
as that used in other steps of the large analysis (e.g., clustering, visualization, trajectory reconstruction).
In practice, if the usual count matrix is not available, one can often achieve satisfactory results
by simply re-using the spliced count matrix as both the \code{"X"} and \code{"spliced"} entries of \code{x}.

Note that if reduced dimensions are supplied in \code{dimred},
any \code{"X"} entry is only used to create the AnnData object and is not used in any actual calculations.
}

\section{Additional arguments to Python}{

Additional arguments to \pkg{scVelo} functions are provided via \code{scvelo.params}.
This is a named list where each entry is named after a function and is itself a named list of arguments for that function.
The following function names are currently recognized:
\itemize{
\item \code{"filter_and_normalize"}, for gene selection and normalization.
This is not used unless \code{use.theirs=TRUE}.
\item \code{"moments"}, for PCA and nearest neighbor detection.
The PCA is not performed if \code{dimred} or \code{use.dimred} is already supplied.
\item \code{"recover_dynamics"}
\item \code{"velocity"}
\item \code{"velocity_graph"}
\item \code{"velocity_pseudotime"}
\item \code{"latent_time"}
\item \code{"velocity_confidence"}
}
See the \pkg{scVelo} documentation for more details about the available arguments and the examples below for a syntax example.
}

\section{Supported operating systems and architectures}{

\pkg{scVelo} dependencies are pinned in a Conda environment to ensure reproducibility.

Differences in packages and versions available from Conda require different environments for different operating systems and architectures.
\pkg{basilisk.utils} is used to determine the operating system and architecture of the computer used to run \code{scvelo()}, using to the appropriate Conda environment.

As of the latest \pkg{velociraptor} update (24 May 2024):

\describe{
\item{All environments}{
\pkg{tqdm} and \pkg{ipywidgets} are installed to suppress the message "Unable to create progress bar".
}
\item{Linux}{\pkg{scVelo} v0.3.2 from conda-forge is used.
This is the latest version available to date.
\pkg{libtiff} is pinned to v4.5.1 and \pkg{pillow} is pinned to v10.0.0 (\url{https://github.com/conda-forge/libtiff-feedstock/issues/104#issuecomment-2375893029}),
\pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
}
\item{Linux AArch64}{\pkg{scVelo} v0.3.2 from conda-forge is used.
This is the latest version available to date.
\pkg{libtiff} is pinned to v4.5.1 and \pkg{pillow} is pinned to v10.0.0 (\url{https://github.com/conda-forge/libtiff-feedstock/issues/104#issuecomment-2375893029}),
\pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
Please note that this environment has not been validated yet; it is derived from the environment from Linux (above) and requires additional testing to identify a working environment before pinning all the packages and versions in the environment.
}
\item{macOS}{\pkg{scVelo} v0.3.2 from conda-forge is used.
This is the latest version available to date.
\pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
}
\item{macOS ARM}{\pkg{scVelo} v0.3.2 from conda-forge is used.
This is the latest version available to date.
\pkg{scipy} is pinned to v1.13.1 (\url{https://github.com/theislab/scvelo/issues/1260}).
}
\item{Windows}{\pkg{scVelo} v0.2.5 from bioconda is used.
Later versions of \pkg{scVelo} depend on \pkg{jaxlib} which is not supported on Windows (\url{https://github.com/google/jax/issues/438}).
\pkg{matplotlib} is pinned to v3.6.3 (\url{https://github.com/scverse/scanpy/issues/2411}),
\pkg{pandas} is pinned to v1.5.2 (\url{https://stackoverflow.com/questions/76234312/importerror-cannot-import-name-is-categorical-from-pandas-api-types}),
and \pkg{numpy} is pinned to v1.21.1 (\url{https://github.com/theislab/scvelo/issues/1109}).
}
}
}

\examples{
# Using mock data to demonstrate the process:
library(scuttle)
sce1 <- mockSCE()
sce2 <- mockSCE()

spliced <- counts(sce1)
unspliced <- counts(sce2)

out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced))

# make scvelo use 10 rather than the default 30 neighbors to compute moments for velocity estimation:
out <- scvelo(list(X=spliced, spliced=spliced, unspliced=unspliced),
              scvelo.params=list(neighbors=list(n_neighbors=10L)))

}
\references{
Bergen, V., Lange, M., Peidli, S. et al. Generalizing RNA velocity to transient cell states through dynamical modeling. Nat Biotechnol 38, 1408–1414 (2020). \url{https://doi.org/10.1038/s41587-020-0591-3}
}
\author{
Aaron Lun, Charlotte Soneson, Kevin Rue-Albrecht
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVelocityStream.R
\name{plotVelocityStream}
\alias{plotVelocityStream}
\title{Velocity stream plot in low-dimensional space}
\usage{
plotVelocityStream(
  sce,
  embedded,
  use.dimred = 1,
  color_by = "#444444",
  color.alpha = 0.2,
  grid.resolution = 60,
  scale = TRUE,
  stream.L = 10,
  stream.min.L = 0,
  stream.res = 4,
  stream.width = 8,
  color.streamlines = FALSE,
  color.streamlines.map = c("#440154", "#482576", "#414487", "#35608D", "#2A788E",
    "#21908C", "#22A884", "#43BF71", "#7AD151", "#BBDF27", "#FDE725"),
  arrow.angle = 8,
  arrow.length = 0.8
)
}
\arguments{
\item{sce}{A \linkS4class{SingleCellExperiment} object containing
low-dimensional coordinates, e.g., after t-SNE, in its
\code{\link{reducedDims}}.}

\item{embedded}{A low-dimensional projection of the velocity vectors into the
embedding of \code{sce}. This should be of the same dimensions as \code{sce}
and is typically produced by \code{\link{embedVelocity}}.}

\item{use.dimred}{String or integer scalar specifying the reduced dimensions
to retrieve from \code{sce}.}

\item{color_by}{A character scalar specifying a column in \code{colData(sce)}
to color cells in the phase graph. Alternatively, \code{color_by} can be
set to a valid R color to be used to color cells.}

\item{color.alpha}{An integer scalar giving the transparency of colored
cells. Possible values are between 0 (fully transparent) and 1.0 (opaque).}

\item{grid.resolution}{Integer scalar specifying the resolution of the grid,
in terms of the number of grid intervals along each axis.}

\item{scale}{Logical scalar indicating whether the averaged vectors should be
scaled by the grid resolution.}

\item{stream.L}{Integer scalar giving the typical length of a streamline
low-dimensional space units.}

\item{stream.min.L}{A numeric scalar with the minimum length of segments to be shown.}

\item{stream.res}{Numeric scalar specifying the resolution of estimated
streamlines (higher numbers increase smoothness of lines but also the time
for computation).}

\item{stream.width}{A numeric scalar controlling the width of streamlines.}

\item{color.streamlines}{Logical scalar. If \code{TRUE} streamlines will
be colored by local velocity. Arrows cannot be shown in that case.}

\item{color.streamlines.map}{A character vector specifying the
color range used for mapping local velocities to streamline colors. The
default is \code{viridisLite::viridis(11)}.}

\item{arrow.angle, arrow.length}{Numeric scalars giving the \code{angle} and
\code{length} of arrowheads.}
}
\value{
A \code{ggplot2} object with the streamline plot.
}
\description{
Plot velocities embedded into low-dimensional space as a stream plot. Stream
lines are lines that follow the gradient in the velocity field and illustrate
paths that cells could follow based on observed RNA velocities.
}
\details{
\code{grid.resolution} and \code{scale} are passed to
  \code{\link{gridVectors}}, which is used to summarized the velocity vectors
  into an initial grid. A full regular grid is computed from that and used
  in \code{\link[metR]{geom_streamline}} to calculate streamlines. The
  following arguments are passed to the arguments given in parenthesis of
  \code{\link[metR]{geom_streamline}}:
  \code{stream.L} (\code{L}), \code{stream.res} (\code{res}),
  \code{stream.min.L} (\code{min.L}), \code{arrow.angle} (\code{arrow.angle})
  and \code{arrow.length} (\code{arrow.length}).
  Streamlines are computed by simple integration with a forward Euler method,
  and \code{stream.L} and \code{stream.res} are used to compute the number of
  steps and the time interval between steps for the integration.
  \code{stream.width} is multiplied with \code{..step..} estimated by
  \code{\link[metR]{geom_streamline}} to control the width of streamlines.
}
\examples{
library(scuttle)
set.seed(42)
sce1 <- mockSCE(ncells = 100, ngenes = 500)
sce2 <- mockSCE(ncells = 100, ngenes = 500)

datlist <- list(X=counts(sce1), spliced=counts(sce1), unspliced=counts(sce2))

out <- scvelo(datlist, mode = "dynamical")

em <- embedVelocity(reducedDim(out, 1), out)[,1:2]

# https://github.com/kevinrue/velociraptor/issues/90

if (!basilisk::isMacOSX()){
  plotVelocityStream(out, em)
  plotVelocityStream(out, em, color.streamlines = TRUE)
}

}
\seealso{
\code{\link{gridVectors}} used to summarize velocity vectors into
  a grid (velocity field), the \pkg{ggplot2} package used for plotting,
  \code{\link[metR]{geom_streamline}} in package \pkg{metR} used to
  calculate and add streamlines from the RNA velocity field to the plot,
  \code{\link[viridisLite]{viridis}} for creation of color palettes.
}
\author{
Michael Stadler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotVelocity.R
\name{plotVelocity}
\alias{plotVelocity}
\title{Phase and velocity graphs for a set of genes}
\usage{
plotVelocity(
  x,
  genes,
  use.dimred = 1,
  assay.splicedM = "Ms",
  assay.unsplicedM = "Mu",
  which.plots = c("phase", "velocity", "expression"),
  genes.per.row = 1,
  color_by = "#222222",
  color.alpha = 0.4,
  colors.velocity = c("#A50026", "#D73027", "#F46D43", "#FDAE61", "#FEE08B", "#FFFFBF",
    "#D9EF8B", "#A6D96A", "#66BD63", "#1A9850", "#006837"),
  colors.expression = c("#440154", "#482576", "#414487", "#35608D", "#2A788E", "#21908C",
    "#22A884", "#43BF71", "#7AD151", "#BBDF27", "#FDE725"),
  max.abs.velo = 0.001
)
}
\arguments{
\item{x}{A \linkS4class{SingleCellExperiment} object with RNA velocity results
as returned by \code{\link{scvelo}}, and low-dimensional coordinates, e.g.,
after t-SNE, in its \code{\link{reducedDims}}.}

\item{genes}{A character vector with one or several genes for which to plot
phase and velocity graphs. \code{genes} have to be in \code{rownames(x)}.}

\item{use.dimred}{String or integer scalar specifying the reduced dimensions
to retrieve from \code{x}.}

\item{assay.splicedM}{An integer scalar or string specifying the assay of
\code{x} containing the moments of spliced abundances.}

\item{assay.unsplicedM}{An integer scalar or string specifying the assay of
\code{x} containing the moments unspliced abundances.}

\item{which.plots}{A character vector specifying which plots to create for
each gene. Possible values are \code{"phase", "velocity", "expression"} and
correspond to the phase graph or reduced dimension graphs with cells
colored by velocity or (spliced) expression.}

\item{genes.per.row}{An integer scalar with the numbers of genes to visualize
per row of plots. For example, if \code{which.plots =  c("phase","expression")}
and \code{genes.per.row = 2}, the resulting figure will have four plot
panels per row.}

\item{color_by}{A character scalar specifying a column in \code{colData(x)}
to color cells in the phase graph. Alternatively, \code{color_by} can be
set to vector of valid R colors, either of length one (recycled for all
cells) or of length \code{ncol(x)}, which will then be used to color cells
in the phase graph.}

\item{color.alpha}{An integer scalar giving the transparency of colored
cells. Possible values are between 0 (fully transparent) and 1.0 (opaque).}

\item{colors.velocity, colors.expression}{Character vectors specifying the
color ranges used for mapping velocities and expression values. The
defaults are \code{RColorBrewer::brewer.pal(11, "RdYlGn")} for the
velocities and \code{viridisLite::viridis(11)} for the expression values.}

\item{max.abs.velo}{A numeric scalar greater than zero giving the maximum
absolute velocity to limit the color scale for the \code{"velocity"} graph.}
}
\value{
A patchwork object with the plots selected by \code{which.plot} for
  the genes in \code{genes}, arranged in a grid according to \code{genes.per.row}.
}
\description{
For a each gene in a set of genes, show the phase graph (spliced versus
unspliced counts and fitted model) and reduced dimension graphs with
cell colored by velocity and (spliced) expression.
}
\details{
Please note that \code{plotVelocity} will modify parameters of
  the current graphics device using \code{\link{layout}} and \code{\link{par}},
  in order to create the layout for the generated graph panels.
}
\examples{
library(scuttle)
set.seed(42)
sce1 <- mockSCE(ncells = 100, ngenes = 500)
sce2 <- mockSCE(ncells = 100, ngenes = 500)

datlist <- list(X=counts(sce1), spliced=counts(sce1), unspliced=counts(sce2))

out1 <- scvelo(datlist, mode = "steady_state")
out2 <- scvelo(datlist, mode = "dynamical")

plotVelocity(out1, c("Gene_0031","Gene_0268"))
plotVelocity(out2, c("Gene_0031","Gene_0268"))

}
\seealso{
\code{\link{scvelo}}, to generate \code{x},
\code{\link[RColorBrewer]{brewer.pal}} and \code{\link[viridisLite]{viridis}}
for creation of color palettes, packages \pkg{ggplot2} and \pkg{patchwork}
used to generate and arrange the plots.
}
\author{
Michael Stadler
}
